// required for old g++ to compile PRId64 macros, see
// https://github.com/pytorch/pytorch/issues/3571
// for context
#ifndef __STDC_FORMAT_MACROS
#define __STDC_FORMAT_MACROS
#endif

// NOTE: This condition is true for all PyTorch internal libraries, it
//       just excludes external projects such as torch_xla which
//       re-use some of the PyTorch codegen machinery.
#if defined(CAFFE2_BUILD_MAIN_LIB)        || \
    defined(TORCH_CUDA_BUILD_MAIN_LIB)    || \
    defined(TORCH_HIP_BUILD_MAIN_LIB)     || \
    defined(TORCH_CUDA_CU_BUILD_MAIN_LIB) || \
    defined(TORCH_CUDA_CPP_BUILD_MAIN_LIB)
#define TORCH_ASSERT_ONLY_METHOD_OPERATORS
#endif

// @generated by tools/codegen/gen.py from RegisterDispatchKey.cpp

#include <c10/core/TensorImpl.h>
#include <c10/core/Allocator.h>
#include <ATen/DeviceGuard.h>
#include <ATen/NamedTensorUtils.h>
#include <ATen/Utils.h>
#include <ATen/WrapDimUtils.h>
#include <ATen/Dispatch.h>
#include <c10/util/ExclusivelyOwned.h>
#include <c10/util/Half.h>
#include <c10/core/UndefinedTensorImpl.h>
#include <c10/util/Optional.h>
#include <ATen/Tensor.h>
#include <ATen/native/Resize.h>

#include <cstddef>
#include <functional>
#include <memory>
#include <utility>

#include <ATen/Config.h>
#include <ATen/core/op_registration/adaption.h>
#include <torch/library.h>


#include <ATen/ops/as_strided_native.h>
#include <ATen/ops/empty.h>
#include <ATen/ops/empty_strided.h>
#include <ATen/ops/_coalesce_native.h>
#include <ATen/ops/_coalesced_native.h>
#include <ATen/ops/_dimI_native.h>
#include <ATen/ops/_dimV_native.h>
#include <ATen/ops/_indices_native.h>
#include <ATen/ops/_nnz_native.h>
#include <ATen/ops/_sparse_broadcast_to_native.h>
#include <ATen/ops/_sparse_coo_tensor_with_dims_and_tensors_native.h>
#include <ATen/ops/_sparse_coo_tensor_with_dims_native.h>
#include <ATen/ops/_sparse_log_softmax_backward_data_native.h>
#include <ATen/ops/_sparse_log_softmax_native.h>
#include <ATen/ops/_sparse_mask_helper_native.h>
#include <ATen/ops/_sparse_softmax_backward_data_native.h>
#include <ATen/ops/_sparse_softmax_native.h>
#include <ATen/ops/_sparse_sparse_matmul_native.h>
#include <ATen/ops/_sparse_sum_backward_native.h>
#include <ATen/ops/_values_native.h>
#include <ATen/ops/abs_native.h>
#include <ATen/ops/add_native.h>
#include <ATen/ops/addmm_native.h>
#include <ATen/ops/any_native.h>
#include <ATen/ops/asin_native.h>
#include <ATen/ops/asinh_native.h>
#include <ATen/ops/atan_native.h>
#include <ATen/ops/atanh_native.h>
#include <ATen/ops/bmm_native.h>
#include <ATen/ops/ceil_native.h>
#include <ATen/ops/clone_native.h>
#include <ATen/ops/conj_physical_native.h>
#include <ATen/ops/copy_native.h>
#include <ATen/ops/copy_sparse_to_sparse_native.h>
#include <ATen/ops/dense_dim_native.h>
#include <ATen/ops/div_native.h>
#include <ATen/ops/empty_like_native.h>
#include <ATen/ops/empty_native.h>
#include <ATen/ops/erf_native.h>
#include <ATen/ops/erfinv_native.h>
#include <ATen/ops/expm1_native.h>
#include <ATen/ops/floor_divide_native.h>
#include <ATen/ops/floor_native.h>
#include <ATen/ops/hspmm_native.h>
#include <ATen/ops/index_select_native.h>
#include <ATen/ops/indices_native.h>
#include <ATen/ops/is_coalesced_native.h>
#include <ATen/ops/isinf_native.h>
#include <ATen/ops/isnan_native.h>
#include <ATen/ops/isneginf_native.h>
#include <ATen/ops/isposinf_native.h>
#include <ATen/ops/log1p_native.h>
#include <ATen/ops/mm_native.h>
#include <ATen/ops/mul_native.h>
#include <ATen/ops/mv_native.h>
#include <ATen/ops/nan_to_num_native.h>
#include <ATen/ops/narrow_copy_native.h>
#include <ATen/ops/native_norm_native.h>
#include <ATen/ops/neg_native.h>
#include <ATen/ops/norm_native.h>
#include <ATen/ops/pow_native.h>
#include <ATen/ops/resize_as_sparse_native.h>
#include <ATen/ops/round_native.h>
#include <ATen/ops/sgn_native.h>
#include <ATen/ops/sign_native.h>
#include <ATen/ops/signbit_native.h>
#include <ATen/ops/sin_native.h>
#include <ATen/ops/sinh_native.h>
#include <ATen/ops/sparse_dim_native.h>
#include <ATen/ops/sparse_mask_native.h>
#include <ATen/ops/sparse_resize_and_clear_native.h>
#include <ATen/ops/sparse_resize_native.h>
#include <ATen/ops/sqrt_native.h>
#include <ATen/ops/sspaddmm_native.h>
#include <ATen/ops/sub_native.h>
#include <ATen/ops/tan_native.h>
#include <ATen/ops/tanh_native.h>
#include <ATen/ops/to_dense_native.h>
#include <ATen/ops/trunc_native.h>
#include <ATen/ops/unsqueeze_native.h>
#include <ATen/ops/values_native.h>
#include <ATen/ops/zero_native.h>


namespace at {

// NB: TORCH_LIBRARY_IMPL must be in an anonymous namespace to avoid
// ambiguity with conflicting identifiers that may have been defined in
// at namespace already.
namespace {


void resize_out(const Tensor &out, IntArrayRef sizes, IntArrayRef strides, const TensorOptions &options) {
  TORCH_CHECK(options.dtype() == out.dtype(),
      "Expected out tensor to have dtype ", options.dtype(), ", but got ", out.dtype(), " instead");
  TORCH_CHECK(options.device() == out.device(),
      "Expected out tensor to have device ", options.device(), ", but got ", out.device(), " instead");
  const bool resized = at::native::resize_output(out, sizes);
  // Only restride if a resize occurred; otherwise we ignore the (advisory)
  // strides from the meta function and directly use the output tensor's
  // preexisting strides
  if (resized) {
    if (!strides.empty()) {
      TORCH_INTERNAL_ASSERT(!options.memory_format_opt().has_value());
      at::native::as_strided_(out, sizes, strides);
    } else if (options.memory_format_opt().has_value()) {
      out.unsafeGetTensorImpl()->empty_tensor_restride(*options.memory_format_opt());
    }
  }
}

void check_inplace(const Tensor &self, IntArrayRef sizes, const TensorOptions &options) {
  // These checks are needed on those operators that:
  //   1) don't use 'TensorIterator' (e.g. 'addmm' and 'baddbmm')
  //   2) have particular typing rules (e.g. 'cumsum' and 'cumprod')
  // For other operators (e.g. 'add'), 'TensorIterator' already checks
  // these things separately.
  TORCH_CHECK(options.dtype() == self.dtype(),
      "Bad in-place call: ",
      "input tensor dtype ", self.dtype(), " and output tensor dtype ", options.dtype(), " should match");
  TORCH_CHECK(options.device() == self.device(),
      "Bad in-place call: ",
      "input tensor device ", self.device(), " and output tensor device ", options.device(), " should match");
  TORCH_CHECK(sizes == self.sizes(),
      "Bad in-place call: ",
      "input tensor size ", self.sizes(), " and output tensor size ", sizes, " should match");
}

namespace {

at::Tensor wrapper__abs(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::abs_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_abs_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::abs_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__abs_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::abs_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__sgn(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sgn_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_sgn_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::sgn_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__sgn_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sgn_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_conj_physical_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::conj_physical_out_sparse(self, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_add_Tensor(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
    // No device check


  // DeviceGuard omitted
  return at::native::add_sparse(self, other, alpha);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_add_out_out(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::add_out_sparse_cpu(self, other, alpha, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_add__Tensor(at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
    // No device check


  // DeviceGuard omitted
  return at::native::add_sparse_(self, other, alpha);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__asinh(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::asinh_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_asinh_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::asinh_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__asinh_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::asinh_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__atanh(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::atanh_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_atanh_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::atanh_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__atanh_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::atanh_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__asin(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::asin_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_asin_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::asin_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__asin_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::asin_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__atan(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::atan_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_atan_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::atan_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__atan_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::atan_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__bmm(const at::Tensor & self, const at::Tensor & mat2) {
    // No device check


  // DeviceGuard omitted
  return at::native::bmm_sparse_cpu(self, mat2);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_bmm_out_out(const at::Tensor & self, const at::Tensor & mat2, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::bmm_out_sparse_cpu(self, mat2, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sparse_broadcast_to(const at::Tensor & self, at::IntArrayRef size) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_broadcast_to(self, size);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__ceil(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::ceil_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_ceil_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::ceil_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__ceil_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::ceil_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__copy_(at::Tensor & self, const at::Tensor & src, bool non_blocking) {
    // No device check


  // DeviceGuard omitted
  return at::native::copy_sparse_wrapper_(self, src, non_blocking);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_div_Tensor(const at::Tensor & self, const at::Tensor & other) {
    // No device check


  // DeviceGuard omitted
  return at::native::div_sparse(self, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_div_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::div_out_sparse_zerodim(self, other, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_div__Tensor(at::Tensor & self, const at::Tensor & other) {
    // No device check


  // DeviceGuard omitted
  return at::native::div_sparse_(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_mode_div_Tensor_mode(const at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode) {
    // No device check


  // DeviceGuard omitted
  return at::native::div_sparse(self, other, rounding_mode);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_mode_div_out_out_mode(const at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::div_out_sparse_zerodim(self, other, rounding_mode, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_mode_div__Tensor_mode(at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode) {
    // No device check


  // DeviceGuard omitted
  return at::native::div_sparse_(self, other, rounding_mode);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_memory_format_empty_memory_format(at::IntArrayRef size, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory, c10::optional<at::MemoryFormat> memory_format) {
    // No device check


  // DeviceGuard omitted
  return at::native::empty_sparse(size, dtype, layout, device, pin_memory, memory_format);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__empty_like(const at::Tensor & self, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory, c10::optional<at::MemoryFormat> memory_format) {
    // No device check


  // DeviceGuard omitted
  return at::native::empty_like_sparse_coo(self, dtype, layout, device, pin_memory, memory_format);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__erf(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::erf_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_erf_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::erf_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__erf_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::erf_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__expm1(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::expm1_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_expm1_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::expm1_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__expm1_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::expm1_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__floor(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::floor_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_floor_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::floor_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__floor_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::floor_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__floor_divide(const at::Tensor & self, const at::Tensor & other) {
    // No device check


  // DeviceGuard omitted
  return at::native::floor_divide_sparse(self, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_floor_divide_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::floor_divide_out_sparse_zerodim(self, other, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_floor_divide__Tensor(at::Tensor & self, const at::Tensor & other) {
    // No device check


  // DeviceGuard omitted
  return at::native::floor_divide_sparse_(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__isnan(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::isnan_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__nan_to_num(const at::Tensor & self, c10::optional<double> nan, c10::optional<double> posinf, c10::optional<double> neginf) {
    // No device check


  // DeviceGuard omitted
  return at::native::nan_to_num_sparse(self, nan, posinf, neginf);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_nan_to_num_out_out(const at::Tensor & self, c10::optional<double> nan, c10::optional<double> posinf, c10::optional<double> neginf, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::nan_to_num_sparse_out(self, nan, posinf, neginf, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__nan_to_num_(at::Tensor & self, c10::optional<double> nan, c10::optional<double> posinf, c10::optional<double> neginf) {
    // No device check


  // DeviceGuard omitted
  return at::native::nan_to_num_sparse_(self, nan, posinf, neginf);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__log1p(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::log1p_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_log1p_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::log1p_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__log1p_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::log1p_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__mm(const at::Tensor & self, const at::Tensor & mat2) {
    // No device check


  // DeviceGuard omitted
  return at::native::_sparse_mm(self, mat2);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_mm_out_out(const at::Tensor & self, const at::Tensor & mat2, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::_sparse_mm_out(self, mat2, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sparse_sparse_matmul(const at::Tensor & self, const at::Tensor & other) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_sparse_matmul_cpu(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sparse_mask_helper(const at::Tensor & t, const at::Tensor & mask_indices) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_mask_helper_cpu(t, mask_indices);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_mul_Tensor(const at::Tensor & self, const at::Tensor & other) {
    // No device check


  // DeviceGuard omitted
  return at::native::mul_sparse(self, other);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_mul_out_out(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::mul_out_sparse_cpu(self, other, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_mul__Tensor(at::Tensor & self, const at::Tensor & other) {
    // No device check


  // DeviceGuard omitted
  return at::native::mul_sparse_(self, other);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__mv(const at::Tensor & self, const at::Tensor & vec) {
    // No device check


  // DeviceGuard omitted
  return at::native::mv_sparse(self, vec);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__narrow_copy(const at::Tensor & self, int64_t dim, int64_t start, int64_t length) {
    // No device check


  // DeviceGuard omitted
  return at::native::narrow_copy_sparse(self, dim, start, length);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__neg(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::neg_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_neg_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::neg_out_sparse(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__neg_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::neg_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__round(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::round_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_round_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::round_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__round_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::round_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__sin(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sin_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_sin_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::sin_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__sin_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sin_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__sinh(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sinh_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_sinh_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::sinh_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__sinh_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sinh_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_sspaddmm_out_out(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::_sspaddmm_out_cpu(self, mat1, mat2, beta, alpha, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__sqrt(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sqrt_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_sqrt_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::sqrt_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__sqrt_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sqrt_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__tan(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::tan_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_tan_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::tan_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__tan_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::tan_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__tanh(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::tanh_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_tanh_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::tanh_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__tanh_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::tanh_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__trunc(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::trunc_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_trunc_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::trunc_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__trunc_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::trunc_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__unsqueeze(const at::Tensor & self, int64_t dim) {
    // No device check


  // DeviceGuard omitted
  return at::native::unsqueeze_sparse(self, dim);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__native_norm(const at::Tensor & self, const at::Scalar & p) {
    // No device check


  // DeviceGuard omitted
  return at::native::norm_sparse(self, p);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_ScalarOpt_dim_dtype_native_norm_ScalarOpt_dim_dtype(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
    // No device check


  // DeviceGuard omitted
  return at::native::norm_sparse(self, p, dim, keepdim, dtype);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sparse_sum_backward(const at::Tensor & grad, const at::Tensor & self, at::IntArrayRef dim) {
    // No device check


  // DeviceGuard omitted
  return at::native::_sparse_sum_backward_cpu(grad, self, dim);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sparse_softmax(const at::Tensor & self, int64_t dim, bool half_to_float) {
    // No device check


  // DeviceGuard omitted
  return at::native::softmax_sparse_cpu(self, dim, half_to_float);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sparse_softmax_backward_data(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::softmax_backward_sparse_cpu(grad_output, output, dim, self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sparse_log_softmax(const at::Tensor & self, int64_t dim, bool half_to_float) {
    // No device check


  // DeviceGuard omitted
  return at::native::log_softmax_sparse_cpu(self, dim, half_to_float);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sparse_log_softmax_backward_data(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::log_softmax_backward_sparse_cpu(grad_output, output, dim, self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_ScalarOpt_dim_dtype_norm_ScalarOpt_dim_dtype(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, at::ScalarType dtype) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_dtype_norm(self, p, dim, keepdim, dtype);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_ScalarOpt_dim_norm_ScalarOpt_dim(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_norm(self, p, dim, keepdim);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__clone(const at::Tensor & self, c10::optional<at::MemoryFormat> memory_format) {
    // No device check


  // DeviceGuard omitted
  return at::native::clone_sparse(self, memory_format);
}

} // anonymous namespace
namespace {

const at::Tensor & wrapper__resize_as_sparse_(const at::Tensor & self, const at::Tensor & the_template) {
    // No device check


  // DeviceGuard omitted
  return at::native::resize_as_sparse_(self, the_template);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__zero_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::zero_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_sub_Tensor(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
    // No device check


  // DeviceGuard omitted
  return at::native::sub_sparse(self, other, alpha);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_sub_out_out(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::sub_out_sparse(self, other, alpha, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_sub__Tensor(at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
    // No device check


  // DeviceGuard omitted
  return at::native::sub_sparse_(self, other, alpha);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__addmm(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
    // No device check


  // DeviceGuard omitted
  return at::native::addmm_sparse_dense_cpu(self, mat1, mat2, beta, alpha);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_addmm_out_out(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::addmm_out_sparse_dense_cpu(self, mat1, mat2, beta, alpha, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__addmm_(at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
    // No device check


  // DeviceGuard omitted
  return at::native::s_addmm_sparse_dense_cpu_(self, mat1, mat2, beta, alpha);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sparse_coo_tensor_with_dims(int64_t sparse_dim, int64_t dense_dim, at::IntArrayRef size, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
    // No device check


  // DeviceGuard omitted
  return at::native::new_with_dims_sparse(sparse_dim, dense_dim, size, dtype, layout, device, pin_memory);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___sparse_coo_tensor_with_dims_and_tensors(int64_t sparse_dim, int64_t dense_dim, at::IntArrayRef size, const at::Tensor & indices, const at::Tensor & values, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
    // No device check


  // DeviceGuard omitted
  return at::native::new_with_dims_and_tensor_sparse(sparse_dim, dense_dim, size, indices, values, dtype, layout, device, pin_memory);
}

} // anonymous namespace
namespace {

const at::Tensor & wrapper__sparse_resize_(const at::Tensor & self, at::IntArrayRef size, int64_t sparse_dim, int64_t dense_dim) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_resize_(self, size, sparse_dim, dense_dim);
}

} // anonymous namespace
namespace {

const at::Tensor & wrapper__sparse_resize_and_clear_(const at::Tensor & self, at::IntArrayRef size, int64_t sparse_dim, int64_t dense_dim) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_resize_and_clear_(self, size, sparse_dim, dense_dim);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__sparse_mask(const at::Tensor & self, const at::Tensor & mask) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_mask_cpu(self, mask);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__to_dense(const at::Tensor & self, c10::optional<at::ScalarType> dtype) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_to_dense(self, dtype);
}

} // anonymous namespace
namespace {

int64_t wrapper__sparse_dim(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_dim_sparse(self);
}

} // anonymous namespace
namespace {

int64_t wrapper___dimI(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sparse_dim_sparse(self);
}

} // anonymous namespace
namespace {

int64_t wrapper__dense_dim(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::dense_dim_sparse(self);
}

} // anonymous namespace
namespace {

int64_t wrapper___dimV(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::dense_dim_sparse(self);
}

} // anonymous namespace
namespace {

int64_t wrapper___nnz(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::_nnz_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___coalesce(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::_coalesce_sparse_cpu(self);
}

} // anonymous namespace
namespace {

bool wrapper__is_coalesced(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::is_coalesced_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___indices(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::_indices_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper___values(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::_values_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper___coalesced_(at::Tensor & self, bool coalesced) {
    // No device check


  // DeviceGuard omitted
  return at::native::_coalesced_sparse_(self, coalesced);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__indices(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::indices_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__values(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::values_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__hspmm(const at::Tensor & mat1, const at::Tensor & mat2) {
    // No device check


  // DeviceGuard omitted
  return at::native::hspmm_sparse_cpu(mat1, mat2);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_hspmm_out_out(const at::Tensor & mat1, const at::Tensor & mat2, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::hspmm_out_sparse_cpu(mat1, mat2, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__copy_sparse_to_sparse_(at::Tensor & self, const at::Tensor & src, bool non_blocking) {
    // No device check


  // DeviceGuard omitted
  return at::native::copy_sparse_(self, src, non_blocking);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__index_select(const at::Tensor & self, int64_t dim, const at::Tensor & index) {
    // No device check


  // DeviceGuard omitted
  return at::native::index_select_sparse(self, dim, index);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__erfinv(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::erfinv_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_erfinv_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::erfinv_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__erfinv_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::erfinv_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__sign(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sign_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_sign_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::sign_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper__sign_(at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::sign_sparse_(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__signbit(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::signbit_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_signbit_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::signbit_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__any(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::any_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper_Tensor_Scalar_pow_Tensor_Scalar(const at::Tensor & self, const at::Scalar & exponent) {
    // No device check


  // DeviceGuard omitted
  return at::native::pow_sparse_scalar(self, exponent);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_Tensor_Scalar_out_pow_out_Tensor_Scalar_out(const at::Tensor & self, const at::Scalar & exponent, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::pow_out_sparse_scalar(self, exponent, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__isinf(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::isinf_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__isposinf(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::isposinf_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_isposinf_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::isposinf_sparse_out(self, out);
}

} // anonymous namespace
namespace {

at::Tensor wrapper__isneginf(const at::Tensor & self) {
    // No device check


  // DeviceGuard omitted
  return at::native::isneginf_sparse(self);
}

} // anonymous namespace
namespace {

at::Tensor & wrapper_out_isneginf_out_out(const at::Tensor & self, at::Tensor & out) {
    // No device check


  // DeviceGuard omitted
  return at::native::isneginf_sparse_out(self, out);
}

} // anonymous namespace

TORCH_LIBRARY_IMPL(aten, SparseCPU, m) {
  m.impl("abs",
  TORCH_FN(wrapper__abs));
  m.impl("abs.out",
  TORCH_FN(wrapper_out_abs_out_out));
  m.impl("abs_",
  TORCH_FN(wrapper__abs_));
  m.impl("sgn",
  TORCH_FN(wrapper__sgn));
  m.impl("sgn.out",
  TORCH_FN(wrapper_out_sgn_out_out));
  m.impl("sgn_",
  TORCH_FN(wrapper__sgn_));
  m.impl("conj_physical.out",
  TORCH_FN(wrapper_out_conj_physical_out_out));
  m.impl("add.Tensor",
  TORCH_FN(wrapper_Tensor_add_Tensor));
  m.impl("add.out",
  TORCH_FN(wrapper_out_add_out_out));
  m.impl("add_.Tensor",
  TORCH_FN(wrapper_Tensor_add__Tensor));
  m.impl("asinh",
  TORCH_FN(wrapper__asinh));
  m.impl("asinh.out",
  TORCH_FN(wrapper_out_asinh_out_out));
  m.impl("asinh_",
  TORCH_FN(wrapper__asinh_));
  m.impl("atanh",
  TORCH_FN(wrapper__atanh));
  m.impl("atanh.out",
  TORCH_FN(wrapper_out_atanh_out_out));
  m.impl("atanh_",
  TORCH_FN(wrapper__atanh_));
  m.impl("asin",
  TORCH_FN(wrapper__asin));
  m.impl("asin.out",
  TORCH_FN(wrapper_out_asin_out_out));
  m.impl("asin_",
  TORCH_FN(wrapper__asin_));
  m.impl("atan",
  TORCH_FN(wrapper__atan));
  m.impl("atan.out",
  TORCH_FN(wrapper_out_atan_out_out));
  m.impl("atan_",
  TORCH_FN(wrapper__atan_));
  m.impl("bmm",
  TORCH_FN(wrapper__bmm));
  m.impl("bmm.out",
  TORCH_FN(wrapper_out_bmm_out_out));
  m.impl("_sparse_broadcast_to",
  TORCH_FN(wrapper___sparse_broadcast_to));
  m.impl("ceil",
  TORCH_FN(wrapper__ceil));
  m.impl("ceil.out",
  TORCH_FN(wrapper_out_ceil_out_out));
  m.impl("ceil_",
  TORCH_FN(wrapper__ceil_));
  m.impl("copy_",
  TORCH_FN(wrapper__copy_));
  m.impl("div.Tensor",
  TORCH_FN(wrapper_Tensor_div_Tensor));
  m.impl("div.out",
  TORCH_FN(wrapper_out_div_out_out));
  m.impl("div_.Tensor",
  TORCH_FN(wrapper_Tensor_div__Tensor));
  m.impl("div.Tensor_mode",
  TORCH_FN(wrapper_Tensor_mode_div_Tensor_mode));
  m.impl("div.out_mode",
  TORCH_FN(wrapper_out_mode_div_out_out_mode));
  m.impl("div_.Tensor_mode",
  TORCH_FN(wrapper_Tensor_mode_div__Tensor_mode));
  m.impl("empty.memory_format",
  TORCH_FN(wrapper_memory_format_empty_memory_format));
  m.impl("empty_like",
  TORCH_FN(wrapper__empty_like));
  m.impl("erf",
  TORCH_FN(wrapper__erf));
  m.impl("erf.out",
  TORCH_FN(wrapper_out_erf_out_out));
  m.impl("erf_",
  TORCH_FN(wrapper__erf_));
  m.impl("expm1",
  TORCH_FN(wrapper__expm1));
  m.impl("expm1.out",
  TORCH_FN(wrapper_out_expm1_out_out));
  m.impl("expm1_",
  TORCH_FN(wrapper__expm1_));
  m.impl("floor",
  TORCH_FN(wrapper__floor));
  m.impl("floor.out",
  TORCH_FN(wrapper_out_floor_out_out));
  m.impl("floor_",
  TORCH_FN(wrapper__floor_));
  m.impl("floor_divide",
  TORCH_FN(wrapper__floor_divide));
  m.impl("floor_divide.out",
  TORCH_FN(wrapper_out_floor_divide_out_out));
  m.impl("floor_divide_.Tensor",
  TORCH_FN(wrapper_Tensor_floor_divide__Tensor));
  m.impl("isnan",
  TORCH_FN(wrapper__isnan));
  m.impl("nan_to_num",
  TORCH_FN(wrapper__nan_to_num));
  m.impl("nan_to_num.out",
  TORCH_FN(wrapper_out_nan_to_num_out_out));
  m.impl("nan_to_num_",
  TORCH_FN(wrapper__nan_to_num_));
  m.impl("log1p",
  TORCH_FN(wrapper__log1p));
  m.impl("log1p.out",
  TORCH_FN(wrapper_out_log1p_out_out));
  m.impl("log1p_",
  TORCH_FN(wrapper__log1p_));
  m.impl("mm",
  TORCH_FN(wrapper__mm));
  m.impl("mm.out",
  TORCH_FN(wrapper_out_mm_out_out));
  m.impl("_sparse_sparse_matmul",
  TORCH_FN(wrapper___sparse_sparse_matmul));
  m.impl("_sparse_mask_helper",
  TORCH_FN(wrapper___sparse_mask_helper));
  m.impl("mul.Tensor",
  TORCH_FN(wrapper_Tensor_mul_Tensor));
  m.impl("mul.out",
  TORCH_FN(wrapper_out_mul_out_out));
  m.impl("mul_.Tensor",
  TORCH_FN(wrapper_Tensor_mul__Tensor));
  m.impl("mv",
  TORCH_FN(wrapper__mv));
  m.impl("narrow_copy",
  TORCH_FN(wrapper__narrow_copy));
  m.impl("neg",
  TORCH_FN(wrapper__neg));
  m.impl("neg.out",
  TORCH_FN(wrapper_out_neg_out_out));
  m.impl("neg_",
  TORCH_FN(wrapper__neg_));
  m.impl("round",
  TORCH_FN(wrapper__round));
  m.impl("round.out",
  TORCH_FN(wrapper_out_round_out_out));
  m.impl("round_",
  TORCH_FN(wrapper__round_));
  m.impl("sin",
  TORCH_FN(wrapper__sin));
  m.impl("sin.out",
  TORCH_FN(wrapper_out_sin_out_out));
  m.impl("sin_",
  TORCH_FN(wrapper__sin_));
  m.impl("sinh",
  TORCH_FN(wrapper__sinh));
  m.impl("sinh.out",
  TORCH_FN(wrapper_out_sinh_out_out));
  m.impl("sinh_",
  TORCH_FN(wrapper__sinh_));
  m.impl("sspaddmm.out",
  TORCH_FN(wrapper_out_sspaddmm_out_out));
  m.impl("sqrt",
  TORCH_FN(wrapper__sqrt));
  m.impl("sqrt.out",
  TORCH_FN(wrapper_out_sqrt_out_out));
  m.impl("sqrt_",
  TORCH_FN(wrapper__sqrt_));
  m.impl("tan",
  TORCH_FN(wrapper__tan));
  m.impl("tan.out",
  TORCH_FN(wrapper_out_tan_out_out));
  m.impl("tan_",
  TORCH_FN(wrapper__tan_));
  m.impl("tanh",
  TORCH_FN(wrapper__tanh));
  m.impl("tanh.out",
  TORCH_FN(wrapper_out_tanh_out_out));
  m.impl("tanh_",
  TORCH_FN(wrapper__tanh_));
  m.impl("trunc",
  TORCH_FN(wrapper__trunc));
  m.impl("trunc.out",
  TORCH_FN(wrapper_out_trunc_out_out));
  m.impl("trunc_",
  TORCH_FN(wrapper__trunc_));
  m.impl("unsqueeze",
  TORCH_FN(wrapper__unsqueeze));
  m.impl("native_norm",
  TORCH_FN(wrapper__native_norm));
  m.impl("native_norm.ScalarOpt_dim_dtype",
  TORCH_FN(wrapper_ScalarOpt_dim_dtype_native_norm_ScalarOpt_dim_dtype));
  m.impl("_sparse_sum_backward",
  TORCH_FN(wrapper___sparse_sum_backward));
  m.impl("_sparse_softmax",
  TORCH_FN(wrapper___sparse_softmax));
  m.impl("_sparse_softmax_backward_data",
  TORCH_FN(wrapper___sparse_softmax_backward_data));
  m.impl("_sparse_log_softmax",
  TORCH_FN(wrapper___sparse_log_softmax));
  m.impl("_sparse_log_softmax_backward_data",
  TORCH_FN(wrapper___sparse_log_softmax_backward_data));
  m.impl("norm.ScalarOpt_dim_dtype",
  TORCH_FN(wrapper_ScalarOpt_dim_dtype_norm_ScalarOpt_dim_dtype));
  m.impl("norm.ScalarOpt_dim",
  TORCH_FN(wrapper_ScalarOpt_dim_norm_ScalarOpt_dim));
  m.impl("clone",
  TORCH_FN(wrapper__clone));
  m.impl("resize_as_sparse_",
  TORCH_FN(wrapper__resize_as_sparse_));
  m.impl("zero_",
  TORCH_FN(wrapper__zero_));
  m.impl("sub.Tensor",
  TORCH_FN(wrapper_Tensor_sub_Tensor));
  m.impl("sub.out",
  TORCH_FN(wrapper_out_sub_out_out));
  m.impl("sub_.Tensor",
  TORCH_FN(wrapper_Tensor_sub__Tensor));
  m.impl("addmm",
  TORCH_FN(wrapper__addmm));
  m.impl("addmm.out",
  TORCH_FN(wrapper_out_addmm_out_out));
  m.impl("addmm_",
  TORCH_FN(wrapper__addmm_));
  m.impl("_sparse_coo_tensor_with_dims",
  TORCH_FN(wrapper___sparse_coo_tensor_with_dims));
  m.impl("_sparse_coo_tensor_with_dims_and_tensors",
  TORCH_FN(wrapper___sparse_coo_tensor_with_dims_and_tensors));
  m.impl("sparse_resize_",
  TORCH_FN(wrapper__sparse_resize_));
  m.impl("sparse_resize_and_clear_",
  TORCH_FN(wrapper__sparse_resize_and_clear_));
  m.impl("sparse_mask",
  TORCH_FN(wrapper__sparse_mask));
  m.impl("to_dense",
  TORCH_FN(wrapper__to_dense));
  m.impl("sparse_dim",
  TORCH_FN(wrapper__sparse_dim));
  m.impl("_dimI",
  TORCH_FN(wrapper___dimI));
  m.impl("dense_dim",
  TORCH_FN(wrapper__dense_dim));
  m.impl("_dimV",
  TORCH_FN(wrapper___dimV));
  m.impl("_nnz",
  TORCH_FN(wrapper___nnz));
  m.impl("_coalesce",
  TORCH_FN(wrapper___coalesce));
  m.impl("is_coalesced",
  TORCH_FN(wrapper__is_coalesced));
  m.impl("_indices",
  TORCH_FN(wrapper___indices));
  m.impl("_values",
  TORCH_FN(wrapper___values));
  m.impl("_coalesced_",
  TORCH_FN(wrapper___coalesced_));
  m.impl("indices",
  TORCH_FN(wrapper__indices));
  m.impl("values",
  TORCH_FN(wrapper__values));
  m.impl("hspmm",
  TORCH_FN(wrapper__hspmm));
  m.impl("hspmm.out",
  TORCH_FN(wrapper_out_hspmm_out_out));
  m.impl("copy_sparse_to_sparse_",
  TORCH_FN(wrapper__copy_sparse_to_sparse_));
  m.impl("index_select",
  TORCH_FN(wrapper__index_select));
  m.impl("erfinv",
  TORCH_FN(wrapper__erfinv));
  m.impl("erfinv.out",
  TORCH_FN(wrapper_out_erfinv_out_out));
  m.impl("erfinv_",
  TORCH_FN(wrapper__erfinv_));
  m.impl("sign",
  TORCH_FN(wrapper__sign));
  m.impl("sign.out",
  TORCH_FN(wrapper_out_sign_out_out));
  m.impl("sign_",
  TORCH_FN(wrapper__sign_));
  m.impl("signbit",
  TORCH_FN(wrapper__signbit));
  m.impl("signbit.out",
  TORCH_FN(wrapper_out_signbit_out_out));
  m.impl("any",
  TORCH_FN(wrapper__any));
  m.impl("pow.Tensor_Scalar",
  TORCH_FN(wrapper_Tensor_Scalar_pow_Tensor_Scalar));
  m.impl("pow.Tensor_Scalar_out",
  TORCH_FN(wrapper_Tensor_Scalar_out_pow_out_Tensor_Scalar_out));
  m.impl("isinf",
  TORCH_FN(wrapper__isinf));
  m.impl("isposinf",
  TORCH_FN(wrapper__isposinf));
  m.impl("isposinf.out",
  TORCH_FN(wrapper_out_isposinf_out_out));
  m.impl("isneginf",
  TORCH_FN(wrapper__isneginf));
  m.impl("isneginf.out",
  TORCH_FN(wrapper_out_isneginf_out_out));
}

} // anonymous namespace

namespace sparsecpu {


at::Tensor abs(const at::Tensor & self) {
return wrapper__abs(self);
}

at::Tensor & abs_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_abs_out_out(self, out);
}

at::Tensor & abs_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_abs_out_out(self, out);
}

at::Tensor & abs_(at::Tensor & self) {
return wrapper__abs_(self);
}

at::Tensor sgn(const at::Tensor & self) {
return wrapper__sgn(self);
}

at::Tensor & sgn_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_sgn_out_out(self, out);
}

at::Tensor & sgn_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_sgn_out_out(self, out);
}

at::Tensor & sgn_(at::Tensor & self) {
return wrapper__sgn_(self);
}

at::Tensor & conj_physical_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_conj_physical_out_out(self, out);
}

at::Tensor & conj_physical_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_conj_physical_out_out(self, out);
}

at::Tensor add(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_Tensor_add_Tensor(self, other, alpha);
}

at::Tensor & add_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_out_add_out_out(self, other, alpha, out);
}

at::Tensor & add_outf(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_out_add_out_out(self, other, alpha, out);
}

at::Tensor & add_(at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_Tensor_add__Tensor(self, other, alpha);
}

at::Tensor asinh(const at::Tensor & self) {
return wrapper__asinh(self);
}

at::Tensor & asinh_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_asinh_out_out(self, out);
}

at::Tensor & asinh_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_asinh_out_out(self, out);
}

at::Tensor & asinh_(at::Tensor & self) {
return wrapper__asinh_(self);
}

at::Tensor atanh(const at::Tensor & self) {
return wrapper__atanh(self);
}

at::Tensor & atanh_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_atanh_out_out(self, out);
}

at::Tensor & atanh_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_atanh_out_out(self, out);
}

at::Tensor & atanh_(at::Tensor & self) {
return wrapper__atanh_(self);
}

at::Tensor asin(const at::Tensor & self) {
return wrapper__asin(self);
}

at::Tensor & asin_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_asin_out_out(self, out);
}

at::Tensor & asin_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_asin_out_out(self, out);
}

at::Tensor & asin_(at::Tensor & self) {
return wrapper__asin_(self);
}

at::Tensor atan(const at::Tensor & self) {
return wrapper__atan(self);
}

at::Tensor & atan_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_atan_out_out(self, out);
}

at::Tensor & atan_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_atan_out_out(self, out);
}

at::Tensor & atan_(at::Tensor & self) {
return wrapper__atan_(self);
}

at::Tensor bmm(const at::Tensor & self, const at::Tensor & mat2) {
return wrapper__bmm(self, mat2);
}

at::Tensor & bmm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & mat2) {
return wrapper_out_bmm_out_out(self, mat2, out);
}

at::Tensor & bmm_outf(const at::Tensor & self, const at::Tensor & mat2, at::Tensor & out) {
return wrapper_out_bmm_out_out(self, mat2, out);
}

at::Tensor _sparse_broadcast_to(const at::Tensor & self, at::IntArrayRef size) {
return wrapper___sparse_broadcast_to(self, size);
}

at::Tensor ceil(const at::Tensor & self) {
return wrapper__ceil(self);
}

at::Tensor & ceil_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_ceil_out_out(self, out);
}

at::Tensor & ceil_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_ceil_out_out(self, out);
}

at::Tensor & ceil_(at::Tensor & self) {
return wrapper__ceil_(self);
}

at::Tensor & copy_(at::Tensor & self, const at::Tensor & src, bool non_blocking) {
return wrapper__copy_(self, src, non_blocking);
}

at::Tensor div(const at::Tensor & self, const at::Tensor & other) {
return wrapper_Tensor_div_Tensor(self, other);
}

at::Tensor & div_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_out_div_out_out(self, other, out);
}

at::Tensor & div_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_out_div_out_out(self, other, out);
}

at::Tensor & div_(at::Tensor & self, const at::Tensor & other) {
return wrapper_Tensor_div__Tensor(self, other);
}

at::Tensor div(const at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode) {
return wrapper_Tensor_mode_div_Tensor_mode(self, other, rounding_mode);
}

at::Tensor & div_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode) {
return wrapper_out_mode_div_out_out_mode(self, other, rounding_mode, out);
}

at::Tensor & div_outf(const at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode, at::Tensor & out) {
return wrapper_out_mode_div_out_out_mode(self, other, rounding_mode, out);
}

at::Tensor & div_(at::Tensor & self, const at::Tensor & other, c10::optional<c10::string_view> rounding_mode) {
return wrapper_Tensor_mode_div__Tensor_mode(self, other, rounding_mode);
}

at::Tensor empty(at::IntArrayRef size, at::TensorOptions options, c10::optional<at::MemoryFormat> memory_format) {
return wrapper_memory_format_empty_memory_format(size, optTypeMetaToScalarType(options.dtype_opt()), options.layout_opt(), options.device_opt(), options.pinned_memory_opt(), c10::impl::check_tensor_options_and_extract_memory_format(options, memory_format));
}

at::Tensor empty(at::IntArrayRef size, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory, c10::optional<at::MemoryFormat> memory_format) {
return wrapper_memory_format_empty_memory_format(size, dtype, layout, device, pin_memory, memory_format);
}

at::Tensor empty_like(const at::Tensor & self, at::TensorOptions options, c10::optional<at::MemoryFormat> memory_format) {
return wrapper__empty_like(self, optTypeMetaToScalarType(options.dtype_opt()), options.layout_opt(), options.device_opt(), options.pinned_memory_opt(), c10::impl::check_tensor_options_and_extract_memory_format(options, memory_format));
}

at::Tensor empty_like(const at::Tensor & self, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory, c10::optional<at::MemoryFormat> memory_format) {
return wrapper__empty_like(self, dtype, layout, device, pin_memory, memory_format);
}

at::Tensor erf(const at::Tensor & self) {
return wrapper__erf(self);
}

at::Tensor & erf_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_erf_out_out(self, out);
}

at::Tensor & erf_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_erf_out_out(self, out);
}

at::Tensor & erf_(at::Tensor & self) {
return wrapper__erf_(self);
}

at::Tensor expm1(const at::Tensor & self) {
return wrapper__expm1(self);
}

at::Tensor & expm1_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_expm1_out_out(self, out);
}

at::Tensor & expm1_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_expm1_out_out(self, out);
}

at::Tensor & expm1_(at::Tensor & self) {
return wrapper__expm1_(self);
}

at::Tensor floor(const at::Tensor & self) {
return wrapper__floor(self);
}

at::Tensor & floor_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_floor_out_out(self, out);
}

at::Tensor & floor_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_floor_out_out(self, out);
}

at::Tensor & floor_(at::Tensor & self) {
return wrapper__floor_(self);
}

at::Tensor floor_divide(const at::Tensor & self, const at::Tensor & other) {
return wrapper__floor_divide(self, other);
}

at::Tensor & floor_divide_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_out_floor_divide_out_out(self, other, out);
}

at::Tensor & floor_divide_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_out_floor_divide_out_out(self, other, out);
}

at::Tensor & floor_divide_(at::Tensor & self, const at::Tensor & other) {
return wrapper_Tensor_floor_divide__Tensor(self, other);
}

at::Tensor isnan(const at::Tensor & self) {
return wrapper__isnan(self);
}

at::Tensor nan_to_num(const at::Tensor & self, c10::optional<double> nan, c10::optional<double> posinf, c10::optional<double> neginf) {
return wrapper__nan_to_num(self, nan, posinf, neginf);
}

at::Tensor & nan_to_num_out(at::Tensor & out, const at::Tensor & self, c10::optional<double> nan, c10::optional<double> posinf, c10::optional<double> neginf) {
return wrapper_out_nan_to_num_out_out(self, nan, posinf, neginf, out);
}

at::Tensor & nan_to_num_outf(const at::Tensor & self, c10::optional<double> nan, c10::optional<double> posinf, c10::optional<double> neginf, at::Tensor & out) {
return wrapper_out_nan_to_num_out_out(self, nan, posinf, neginf, out);
}

at::Tensor & nan_to_num_(at::Tensor & self, c10::optional<double> nan, c10::optional<double> posinf, c10::optional<double> neginf) {
return wrapper__nan_to_num_(self, nan, posinf, neginf);
}

at::Tensor log1p(const at::Tensor & self) {
return wrapper__log1p(self);
}

at::Tensor & log1p_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_log1p_out_out(self, out);
}

at::Tensor & log1p_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_log1p_out_out(self, out);
}

at::Tensor & log1p_(at::Tensor & self) {
return wrapper__log1p_(self);
}

at::Tensor mm(const at::Tensor & self, const at::Tensor & mat2) {
return wrapper__mm(self, mat2);
}

at::Tensor & mm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & mat2) {
return wrapper_out_mm_out_out(self, mat2, out);
}

at::Tensor & mm_outf(const at::Tensor & self, const at::Tensor & mat2, at::Tensor & out) {
return wrapper_out_mm_out_out(self, mat2, out);
}

at::Tensor _sparse_sparse_matmul(const at::Tensor & self, const at::Tensor & other) {
return wrapper___sparse_sparse_matmul(self, other);
}

at::Tensor _sparse_mask_helper(const at::Tensor & t, const at::Tensor & mask_indices) {
return wrapper___sparse_mask_helper(t, mask_indices);
}

at::Tensor mul(const at::Tensor & self, const at::Tensor & other) {
return wrapper_Tensor_mul_Tensor(self, other);
}

at::Tensor & mul_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other) {
return wrapper_out_mul_out_out(self, other, out);
}

at::Tensor & mul_outf(const at::Tensor & self, const at::Tensor & other, at::Tensor & out) {
return wrapper_out_mul_out_out(self, other, out);
}

at::Tensor & mul_(at::Tensor & self, const at::Tensor & other) {
return wrapper_Tensor_mul__Tensor(self, other);
}

at::Tensor mv(const at::Tensor & self, const at::Tensor & vec) {
return wrapper__mv(self, vec);
}

at::Tensor narrow_copy(const at::Tensor & self, int64_t dim, int64_t start, int64_t length) {
return wrapper__narrow_copy(self, dim, start, length);
}

at::Tensor neg(const at::Tensor & self) {
return wrapper__neg(self);
}

at::Tensor & neg_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_neg_out_out(self, out);
}

at::Tensor & neg_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_neg_out_out(self, out);
}

at::Tensor & neg_(at::Tensor & self) {
return wrapper__neg_(self);
}

at::Tensor round(const at::Tensor & self) {
return wrapper__round(self);
}

at::Tensor & round_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_round_out_out(self, out);
}

at::Tensor & round_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_round_out_out(self, out);
}

at::Tensor & round_(at::Tensor & self) {
return wrapper__round_(self);
}

at::Tensor sin(const at::Tensor & self) {
return wrapper__sin(self);
}

at::Tensor & sin_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_sin_out_out(self, out);
}

at::Tensor & sin_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_sin_out_out(self, out);
}

at::Tensor & sin_(at::Tensor & self) {
return wrapper__sin_(self);
}

at::Tensor sinh(const at::Tensor & self) {
return wrapper__sinh(self);
}

at::Tensor & sinh_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_sinh_out_out(self, out);
}

at::Tensor & sinh_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_sinh_out_out(self, out);
}

at::Tensor & sinh_(at::Tensor & self) {
return wrapper__sinh_(self);
}

at::Tensor & sspaddmm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_out_sspaddmm_out_out(self, mat1, mat2, beta, alpha, out);
}

at::Tensor & sspaddmm_outf(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_out_sspaddmm_out_out(self, mat1, mat2, beta, alpha, out);
}

at::Tensor sqrt(const at::Tensor & self) {
return wrapper__sqrt(self);
}

at::Tensor & sqrt_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_sqrt_out_out(self, out);
}

at::Tensor & sqrt_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_sqrt_out_out(self, out);
}

at::Tensor & sqrt_(at::Tensor & self) {
return wrapper__sqrt_(self);
}

at::Tensor tan(const at::Tensor & self) {
return wrapper__tan(self);
}

at::Tensor & tan_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_tan_out_out(self, out);
}

at::Tensor & tan_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_tan_out_out(self, out);
}

at::Tensor & tan_(at::Tensor & self) {
return wrapper__tan_(self);
}

at::Tensor tanh(const at::Tensor & self) {
return wrapper__tanh(self);
}

at::Tensor & tanh_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_tanh_out_out(self, out);
}

at::Tensor & tanh_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_tanh_out_out(self, out);
}

at::Tensor & tanh_(at::Tensor & self) {
return wrapper__tanh_(self);
}

at::Tensor trunc(const at::Tensor & self) {
return wrapper__trunc(self);
}

at::Tensor & trunc_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_trunc_out_out(self, out);
}

at::Tensor & trunc_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_trunc_out_out(self, out);
}

at::Tensor & trunc_(at::Tensor & self) {
return wrapper__trunc_(self);
}

at::Tensor unsqueeze(const at::Tensor & self, int64_t dim) {
return wrapper__unsqueeze(self, dim);
}

at::Tensor native_norm(const at::Tensor & self, const at::Scalar & p) {
return wrapper__native_norm(self, p);
}

at::Tensor native_norm(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, c10::optional<at::ScalarType> dtype) {
return wrapper_ScalarOpt_dim_dtype_native_norm_ScalarOpt_dim_dtype(self, p, dim, keepdim, dtype);
}

at::Tensor _sparse_sum_backward(const at::Tensor & grad, const at::Tensor & self, at::IntArrayRef dim) {
return wrapper___sparse_sum_backward(grad, self, dim);
}

at::Tensor _sparse_softmax(const at::Tensor & self, int64_t dim, bool half_to_float) {
return wrapper___sparse_softmax(self, dim, half_to_float);
}

at::Tensor _sparse_softmax_backward_data(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, const at::Tensor & self) {
return wrapper___sparse_softmax_backward_data(grad_output, output, dim, self);
}

at::Tensor _sparse_log_softmax(const at::Tensor & self, int64_t dim, bool half_to_float) {
return wrapper___sparse_log_softmax(self, dim, half_to_float);
}

at::Tensor _sparse_log_softmax_backward_data(const at::Tensor & grad_output, const at::Tensor & output, int64_t dim, const at::Tensor & self) {
return wrapper___sparse_log_softmax_backward_data(grad_output, output, dim, self);
}

at::Tensor norm(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim, at::ScalarType dtype) {
return wrapper_ScalarOpt_dim_dtype_norm_ScalarOpt_dim_dtype(self, p, dim, keepdim, dtype);
}

at::Tensor norm(const at::Tensor & self, const c10::optional<at::Scalar> & p, at::IntArrayRef dim, bool keepdim) {
return wrapper_ScalarOpt_dim_norm_ScalarOpt_dim(self, p, dim, keepdim);
}

at::Tensor clone(const at::Tensor & self, c10::optional<at::MemoryFormat> memory_format) {
return wrapper__clone(self, memory_format);
}

const at::Tensor & resize_as_sparse_(const at::Tensor & self, const at::Tensor & the_template) {
return wrapper__resize_as_sparse_(self, the_template);
}

at::Tensor & zero_(at::Tensor & self) {
return wrapper__zero_(self);
}

at::Tensor sub(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_Tensor_sub_Tensor(self, other, alpha);
}

at::Tensor & sub_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_out_sub_out_out(self, other, alpha, out);
}

at::Tensor & sub_outf(const at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_out_sub_out_out(self, other, alpha, out);
}

at::Tensor & sub_(at::Tensor & self, const at::Tensor & other, const at::Scalar & alpha) {
return wrapper_Tensor_sub__Tensor(self, other, alpha);
}

at::Tensor addmm(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper__addmm(self, mat1, mat2, beta, alpha);
}

at::Tensor & addmm_out(at::Tensor & out, const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper_out_addmm_out_out(self, mat1, mat2, beta, alpha, out);
}

at::Tensor & addmm_outf(const at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha, at::Tensor & out) {
return wrapper_out_addmm_out_out(self, mat1, mat2, beta, alpha, out);
}

at::Tensor & addmm_(at::Tensor & self, const at::Tensor & mat1, const at::Tensor & mat2, const at::Scalar & beta, const at::Scalar & alpha) {
return wrapper__addmm_(self, mat1, mat2, beta, alpha);
}

at::Tensor _sparse_coo_tensor_with_dims(int64_t sparse_dim, int64_t dense_dim, at::IntArrayRef size, at::TensorOptions options) {
return wrapper___sparse_coo_tensor_with_dims(sparse_dim, dense_dim, size, optTypeMetaToScalarType(options.dtype_opt()), options.layout_opt(), options.device_opt(), options.pinned_memory_opt());
}

at::Tensor _sparse_coo_tensor_with_dims(int64_t sparse_dim, int64_t dense_dim, at::IntArrayRef size, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
return wrapper___sparse_coo_tensor_with_dims(sparse_dim, dense_dim, size, dtype, layout, device, pin_memory);
}

at::Tensor _sparse_coo_tensor_with_dims_and_tensors(int64_t sparse_dim, int64_t dense_dim, at::IntArrayRef size, const at::Tensor & indices, const at::Tensor & values, at::TensorOptions options) {
return wrapper___sparse_coo_tensor_with_dims_and_tensors(sparse_dim, dense_dim, size, indices, values, optTypeMetaToScalarType(options.dtype_opt()), options.layout_opt(), options.device_opt(), options.pinned_memory_opt());
}

at::Tensor _sparse_coo_tensor_with_dims_and_tensors(int64_t sparse_dim, int64_t dense_dim, at::IntArrayRef size, const at::Tensor & indices, const at::Tensor & values, c10::optional<at::ScalarType> dtype, c10::optional<at::Layout> layout, c10::optional<at::Device> device, c10::optional<bool> pin_memory) {
return wrapper___sparse_coo_tensor_with_dims_and_tensors(sparse_dim, dense_dim, size, indices, values, dtype, layout, device, pin_memory);
}

const at::Tensor & sparse_resize_(const at::Tensor & self, at::IntArrayRef size, int64_t sparse_dim, int64_t dense_dim) {
return wrapper__sparse_resize_(self, size, sparse_dim, dense_dim);
}

const at::Tensor & sparse_resize_and_clear_(const at::Tensor & self, at::IntArrayRef size, int64_t sparse_dim, int64_t dense_dim) {
return wrapper__sparse_resize_and_clear_(self, size, sparse_dim, dense_dim);
}

at::Tensor sparse_mask(const at::Tensor & self, const at::Tensor & mask) {
return wrapper__sparse_mask(self, mask);
}

at::Tensor to_dense(const at::Tensor & self, c10::optional<at::ScalarType> dtype) {
return wrapper__to_dense(self, dtype);
}

int64_t sparse_dim(const at::Tensor & self) {
return wrapper__sparse_dim(self);
}

int64_t _dimI(const at::Tensor & self) {
return wrapper___dimI(self);
}

int64_t dense_dim(const at::Tensor & self) {
return wrapper__dense_dim(self);
}

int64_t _dimV(const at::Tensor & self) {
return wrapper___dimV(self);
}

int64_t _nnz(const at::Tensor & self) {
return wrapper___nnz(self);
}

at::Tensor _coalesce(const at::Tensor & self) {
return wrapper___coalesce(self);
}

bool is_coalesced(const at::Tensor & self) {
return wrapper__is_coalesced(self);
}

at::Tensor _indices(const at::Tensor & self) {
return wrapper___indices(self);
}

at::Tensor _values(const at::Tensor & self) {
return wrapper___values(self);
}

at::Tensor & _coalesced_(at::Tensor & self, bool coalesced) {
return wrapper___coalesced_(self, coalesced);
}

at::Tensor indices(const at::Tensor & self) {
return wrapper__indices(self);
}

at::Tensor values(const at::Tensor & self) {
return wrapper__values(self);
}

at::Tensor hspmm(const at::Tensor & mat1, const at::Tensor & mat2) {
return wrapper__hspmm(mat1, mat2);
}

at::Tensor & hspmm_out(at::Tensor & out, const at::Tensor & mat1, const at::Tensor & mat2) {
return wrapper_out_hspmm_out_out(mat1, mat2, out);
}

at::Tensor & hspmm_outf(const at::Tensor & mat1, const at::Tensor & mat2, at::Tensor & out) {
return wrapper_out_hspmm_out_out(mat1, mat2, out);
}

at::Tensor & copy_sparse_to_sparse_(at::Tensor & self, const at::Tensor & src, bool non_blocking) {
return wrapper__copy_sparse_to_sparse_(self, src, non_blocking);
}

at::Tensor index_select(const at::Tensor & self, int64_t dim, const at::Tensor & index) {
return wrapper__index_select(self, dim, index);
}

at::Tensor erfinv(const at::Tensor & self) {
return wrapper__erfinv(self);
}

at::Tensor & erfinv_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_erfinv_out_out(self, out);
}

at::Tensor & erfinv_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_erfinv_out_out(self, out);
}

at::Tensor & erfinv_(at::Tensor & self) {
return wrapper__erfinv_(self);
}

at::Tensor sign(const at::Tensor & self) {
return wrapper__sign(self);
}

at::Tensor & sign_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_sign_out_out(self, out);
}

at::Tensor & sign_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_sign_out_out(self, out);
}

at::Tensor & sign_(at::Tensor & self) {
return wrapper__sign_(self);
}

at::Tensor signbit(const at::Tensor & self) {
return wrapper__signbit(self);
}

at::Tensor & signbit_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_signbit_out_out(self, out);
}

at::Tensor & signbit_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_signbit_out_out(self, out);
}

at::Tensor any(const at::Tensor & self) {
return wrapper__any(self);
}

at::Tensor pow(const at::Tensor & self, const at::Scalar & exponent) {
return wrapper_Tensor_Scalar_pow_Tensor_Scalar(self, exponent);
}

at::Tensor & pow_out(at::Tensor & out, const at::Tensor & self, const at::Scalar & exponent) {
return wrapper_Tensor_Scalar_out_pow_out_Tensor_Scalar_out(self, exponent, out);
}

at::Tensor & pow_outf(const at::Tensor & self, const at::Scalar & exponent, at::Tensor & out) {
return wrapper_Tensor_Scalar_out_pow_out_Tensor_Scalar_out(self, exponent, out);
}

at::Tensor isinf(const at::Tensor & self) {
return wrapper__isinf(self);
}

at::Tensor isposinf(const at::Tensor & self) {
return wrapper__isposinf(self);
}

at::Tensor & isposinf_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_isposinf_out_out(self, out);
}

at::Tensor & isposinf_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_isposinf_out_out(self, out);
}

at::Tensor isneginf(const at::Tensor & self) {
return wrapper__isneginf(self);
}

at::Tensor & isneginf_out(at::Tensor & out, const at::Tensor & self) {
return wrapper_out_isneginf_out_out(self, out);
}

at::Tensor & isneginf_outf(const at::Tensor & self, at::Tensor & out) {
return wrapper_out_isneginf_out_out(self, out);
}

} // namespace sparsecpu

} // namespace at
