#include <ATen/core/ATenOpList.h>

#include <string>
#include <cstring>
#include <utility>
#include <unordered_set>
#include <ATen/core/operator_name.h>

// @generated by tools/codegen/gen.py from ATenOpList.cpp

namespace at {

namespace {
struct OpNameEquals final {
  bool operator()(const std::pair<const char*, const char*>& lhs, const std::pair<const char*, const char*>& rhs) const {
      return 0 == strcmp(lhs.first, rhs.first) && 0 == strcmp(lhs.second, rhs.second);
  }
};

struct OpNameHash final {
  size_t operator()(const std::pair<const char*, const char*>& p) const {
      // use std::hash<std::string> because std::hash<const char*> would hash pointers and not pointed-to strings
      return std::hash<std::string>()(p.first) ^ (~ std::hash<std::string>()(p.second));
  }
};
}

bool is_custom_op(const c10::OperatorName& opName) {
  static std::unordered_set<std::pair<const char*, const char*>, OpNameHash, OpNameEquals> ops {
    {"aten::_cast_Byte", ""},
    {"aten::_cast_Char", ""},
    {"aten::_cast_Double", ""},
    {"aten::_cast_Float", ""},
    {"aten::_cast_Int", ""},
    {"aten::_cast_Long", ""},
    {"aten::_cast_Short", ""},
    {"aten::_cast_Half", ""},
    {"aten::_backward", ""},
    {"aten::set_data", ""},
    {"aten::data", ""},
    {"aten::is_leaf", ""},
    {"aten::output_nr", ""},
    {"aten::_version", ""},
    {"aten::requires_grad_", ""},
    {"aten::retain_grad", ""},
    {"aten::retains_grad", ""},
    {"aten::_fw_primal", ""},
    {"aten::_make_dual", ""},
    {"aten::_unpack_dual", ""},
    {"aten::_new_zeros_with_same_feature_meta", ""},
    {"aten::_has_same_storage_numel", ""},
    {"aten::rename_", ""},
    {"aten::rename", ""},
    {"aten::align_to", ""},
    {"aten::align_to", "ellipsis_idx"},
    {"aten::align_as", ""},
    {"aten::align_tensors", ""},
    {"aten::_assert_async", ""},
    {"aten::refine_names", ""},
    {"aten::_use_cudnn_ctc_loss", ""},
    {"aten::_cudnn_ctc_loss", ""},
    {"aten::_use_cudnn_rnn_flatten_weight", ""},
    {"aten::_cudnn_rnn_flatten_weight", ""},
    {"aten::_cudnn_rnn", ""},
    {"aten::_cudnn_rnn_backward", ""},
    {"aten::_cudnn_init_dropout_state", ""},
    {"aten::_debug_has_internal_overlap", ""},
    {"aten::_fused_dropout", ""},
    {"aten::_masked_scale", ""},
    {"aten::native_dropout", ""},
    {"aten::native_dropout_backward", ""},
    {"aten::_sobol_engine_draw", ""},
    {"aten::_sobol_engine_ff_", ""},
    {"aten::_sobol_engine_scramble_", ""},
    {"aten::_sobol_engine_initialize_state_", ""},
    {"aten::_reshape_from_tensor", ""},
    {"aten::_shape_as_tensor", ""},
    {"aten::dropout", ""},
    {"aten::dropout_", ""},
    {"aten::feature_dropout", ""},
    {"aten::feature_dropout_", ""},
    {"aten::alpha_dropout", ""},
    {"aten::alpha_dropout_", ""},
    {"aten::feature_alpha_dropout", ""},
    {"aten::feature_alpha_dropout_", ""},
    {"aten::abs", ""},
    {"aten::abs_", ""},
    {"aten::abs", "out"},
    {"aten::absolute", ""},
    {"aten::absolute_", ""},
    {"aten::absolute", "out"},
    {"aten::angle", ""},
    {"aten::angle", "out"},
    {"aten::view_as_real", ""},
    {"aten::view_as_complex", ""},
    {"aten::sgn", ""},
    {"aten::sgn_", ""},
    {"aten::sgn", "out"},
    {"aten::real", ""},
    {"aten::imag", ""},
    {"aten::_conj", ""},
    {"aten::conj", ""},
    {"aten::_conj_physical", ""},
    {"aten::conj_physical", ""},
    {"aten::conj_physical", "out"},
    {"aten::conj_physical_", ""},
    {"aten::resolve_conj", ""},
    {"aten::resolve_neg", ""},
    {"aten::_neg_view", ""},
    {"aten::acos", ""},
    {"aten::acos_", ""},
    {"aten::acos", "out"},
    {"aten::arccos", ""},
    {"aten::arccos_", ""},
    {"aten::arccos", "out"},
    {"aten::avg_pool1d", ""},
    {"aten::adaptive_avg_pool1d", ""},
    {"aten::adaptive_max_pool1d", ""},
    {"aten::add", "Tensor"},
    {"aten::add_", "Tensor"},
    {"aten::add", "out"},
    {"aten::_add_relu", "Tensor"},
    {"aten::_add_relu_", "Tensor"},
    {"aten::_add_relu", "out"},
    {"aten::_add_relu", "Scalar"},
    {"aten::_add_relu_", "Scalar"},
    {"aten::add", "Scalar"},
    {"aten::add_", "Scalar"},
    {"aten::addmv", ""},
    {"aten::addmv_", ""},
    {"aten::addmv", "out"},
    {"aten::addr", ""},
    {"aten::addr_", ""},
    {"aten::addr", "out"},
    {"aten::affine_grid_generator", ""},
    {"aten::affine_grid_generator_backward", ""},
    {"aten::all", "dim"},
    {"aten::all", "out"},
    {"aten::all", "dimname"},
    {"aten::all", "dimname_out"},
    {"aten::allclose", ""},
    {"aten::any", "dim"},
    {"aten::any", "out"},
    {"aten::any", "dimname"},
    {"aten::any", "dimname_out"},
    {"aten::arange", ""},
    {"aten::arange", "start"},
    {"aten::arange", "start_step"},
    {"aten::arange", "out"},
    {"aten::arange", "start_out"},
    {"aten::_dim_arange", ""},
    {"aten::argmax", ""},
    {"aten::argmax", "out"},
    {"aten::argmin", ""},
    {"aten::argmin", "out"},
    {"aten::acosh", ""},
    {"aten::acosh_", ""},
    {"aten::acosh", "out"},
    {"aten::arccosh", ""},
    {"aten::arccosh_", ""},
    {"aten::arccosh", "out"},
    {"aten::asinh", ""},
    {"aten::asinh_", ""},
    {"aten::asinh", "out"},
    {"aten::arcsinh", ""},
    {"aten::arcsinh_", ""},
    {"aten::arcsinh", "out"},
    {"aten::atanh", ""},
    {"aten::atanh_", ""},
    {"aten::atanh", "out"},
    {"aten::arctanh", ""},
    {"aten::arctanh_", ""},
    {"aten::arctanh", "out"},
    {"aten::as_strided", ""},
    {"aten::as_strided_", ""},
    {"aten::asin", ""},
    {"aten::asin_", ""},
    {"aten::asin", "out"},
    {"aten::arcsin", ""},
    {"aten::arcsin_", ""},
    {"aten::arcsin", "out"},
    {"aten::atan", ""},
    {"aten::atan_", ""},
    {"aten::atan", "out"},
    {"aten::arctan", ""},
    {"aten::arctan_", ""},
    {"aten::arctan", "out"},
    {"aten::atleast_1d", ""},
    {"aten::atleast_1d", "Sequence"},
    {"aten::atleast_2d", ""},
    {"aten::atleast_2d", "Sequence"},
    {"aten::atleast_3d", ""},
    {"aten::atleast_3d", "Sequence"},
    {"aten::baddbmm", ""},
    {"aten::baddbmm_", ""},
    {"aten::baddbmm", "out"},
    {"aten::bartlett_window", ""},
    {"aten::bartlett_window", "periodic"},
    {"aten::batch_norm", ""},
    {"aten::quantized_batch_norm", ""},
    {"aten::_batch_norm_impl_index", ""},
    {"aten::_batch_norm_impl_index_backward", ""},
    {"aten::bernoulli", ""},
    {"aten::bernoulli", "out"},
    {"aten::bernoulli_", "Tensor"},
    {"aten::bernoulli_", "float"},
    {"aten::bernoulli", "p"},
    {"aten::bilinear", ""},
    {"aten::binary_cross_entropy", ""},
    {"aten::binary_cross_entropy", "out"},
    {"aten::binary_cross_entropy_backward", ""},
    {"aten::binary_cross_entropy_backward", "grad_input"},
    {"aten::binary_cross_entropy_with_logits", ""},
    {"aten::binary_cross_entropy_with_logits_backward", ""},
    {"aten::bincount", ""},
    {"aten::bitwise_not", ""},
    {"aten::bitwise_not_", ""},
    {"aten::bitwise_not", "out"},
    {"aten::copysign", "out"},
    {"aten::copysign", "Tensor"},
    {"aten::copysign_", "Tensor"},
    {"aten::copysign", "Scalar"},
    {"aten::copysign_", "Scalar"},
    {"aten::copysign", "Scalar_out"},
    {"aten::logical_not", ""},
    {"aten::logical_not_", ""},
    {"aten::logical_not", "out"},
    {"aten::logical_xor", ""},
    {"aten::logical_xor_", ""},
    {"aten::logical_xor", "out"},
    {"aten::logical_and", ""},
    {"aten::logical_and_", ""},
    {"aten::logical_and", "out"},
    {"aten::logical_or", ""},
    {"aten::logical_or_", ""},
    {"aten::logical_or", "out"},
    {"aten::blackman_window", ""},
    {"aten::blackman_window", "periodic"},
    {"aten::bmm", ""},
    {"aten::bmm", "out"},
    {"aten::broadcast_tensors", ""},
    {"aten::broadcast_to", ""},
    {"aten::_sparse_broadcast_to", ""},
    {"aten::cat", ""},
    {"aten::cat", "out"},
    {"aten::cat", "names"},
    {"aten::cat", "names_out"},
    {"aten::concat", ""},
    {"aten::concat", "out"},
    {"aten::concat", "names"},
    {"aten::concat", "names_out"},
    {"aten::block_diag", ""},
    {"aten::ceil", ""},
    {"aten::ceil_", ""},
    {"aten::ceil", "out"},
    {"aten::chain_matmul", ""},
    {"aten::chain_matmul", "out"},
    {"aten::unsafe_chunk", ""},
    {"aten::chunk", ""},
    {"aten::tensor_split", "sections"},
    {"aten::tensor_split", "indices"},
    {"aten::tensor_split", "tensor_indices_or_sections"},
    {"aten::clamp", ""},
    {"aten::clamp", "Tensor"},
    {"aten::clamp_", ""},
    {"aten::clamp_", "Tensor"},
    {"aten::clamp", "out"},
    {"aten::clamp", "Tensor_out"},
    {"aten::clamp_max", ""},
    {"aten::clamp_max", "Tensor"},
    {"aten::clamp_max_", ""},
    {"aten::clamp_max_", "Tensor"},
    {"aten::clamp_max", "out"},
    {"aten::clamp_max", "Tensor_out"},
    {"aten::clamp_min", ""},
    {"aten::clamp_min", "Tensor"},
    {"aten::clamp_min_", ""},
    {"aten::clamp_min_", "Tensor"},
    {"aten::clamp_min", "out"},
    {"aten::clamp_min", "Tensor_out"},
    {"aten::clip", ""},
    {"aten::clip", "Tensor"},
    {"aten::clip_", ""},
    {"aten::clip_", "Tensor"},
    {"aten::clip", "out"},
    {"aten::clip", "Tensor_out"},
    {"aten::cudnn_is_acceptable", ""},
    {"aten::complex", ""},
    {"aten::complex", "out"},
    {"aten::polar", ""},
    {"aten::polar", "out"},
    {"aten::constant_pad_nd", ""},
    {"aten::contiguous", ""},
    {"aten::convolution", ""},
    {"aten::convolution_backward", ""},
    {"aten::convolution_overrideable", ""},
    {"aten::convolution_backward_overrideable", ""},
    {"aten::_convolution", ""},
    {"aten::_convolution", "deprecated"},
    {"aten::_convolution_mode", ""},
    {"aten::_convolution_double_backward", ""},
    {"aten::conv1d", ""},
    {"aten::conv2d", ""},
    {"aten::conv3d", ""},
    {"aten::conv1d", "padding"},
    {"aten::conv2d", "padding"},
    {"aten::conv3d", "padding"},
    {"aten::conv_tbc", ""},
    {"aten::conv_tbc_backward", ""},
    {"aten::conv_transpose1d", ""},
    {"aten::conv_transpose2d", "input"},
    {"aten::conv_transpose3d", "input"},
    {"aten::copy_", ""},
    {"aten::_copy_from", ""},
    {"aten::_copy_from_and_resize", ""},
    {"aten::cos", ""},
    {"aten::cos_", ""},
    {"aten::cos", "out"},
    {"aten::cosh", ""},
    {"aten::cosh_", ""},
    {"aten::cosh", "out"},
    {"aten::cosine_embedding_loss", ""},
    {"aten::count_nonzero", "dim_IntList"},
    {"aten::count_nonzero", ""},
    {"aten::cov", ""},
    {"aten::corrcoef", ""},
    {"aten::cudnn_affine_grid_generator", ""},
    {"aten::cudnn_affine_grid_generator_backward", ""},
    {"aten::cudnn_batch_norm", ""},
    {"aten::cudnn_batch_norm_backward", ""},
    {"aten::cudnn_convolution", ""},
    {"aten::cudnn_convolution_transpose", ""},
    {"aten::cudnn_convolution_relu", ""},
    {"aten::cudnn_convolution_add_relu", ""},
    {"aten::cudnn_grid_sampler", ""},
    {"aten::cudnn_grid_sampler_backward", ""},
    {"aten::cummax", ""},
    {"aten::cummax", "out"},
    {"aten::cummax", "dimname"},
    {"aten::cummax", "dimname_out"},
    {"aten::_cummax_helper", ""},
    {"aten::cummin", ""},
    {"aten::cummin", "out"},
    {"aten::cummin", "dimname"},
    {"aten::cummin", "dimname_out"},
    {"aten::_cummin_helper", ""},
    {"aten::cummaxmin_backward", ""},
    {"aten::cumprod", ""},
    {"aten::cumprod_", ""},
    {"aten::cumprod", "out"},
    {"aten::cumprod", "dimname"},
    {"aten::cumprod_", "dimname"},
    {"aten::cumprod", "dimname_out"},
    {"aten::cumprod_backward", ""},
    {"aten::cumsum", ""},
    {"aten::cumsum_", ""},
    {"aten::cumsum", "out"},
    {"aten::cumsum", "dimname"},
    {"aten::cumsum_", "dimname"},
    {"aten::cumsum", "dimname_out"},
    {"aten::cumulative_trapezoid", "x"},
    {"aten::cumulative_trapezoid", "dx"},
    {"aten::ctc_loss", "IntList"},
    {"aten::ctc_loss", "Tensor"},
    {"aten::_ctc_loss", ""},
    {"aten::_ctc_loss_backward", ""},
    {"aten::diag_embed", ""},
    {"aten::diagflat", ""},
    {"aten::diagonal", ""},
    {"aten::linalg_diagonal", ""},
    {"aten::diagonal", "Dimname"},
    {"aten::diagonal_backward", ""},
    {"aten::fill_diagonal_", ""},
    {"aten::diff", ""},
    {"aten::diff", "out"},
    {"aten::gradient", "scalarint"},
    {"aten::gradient", "scalararray"},
    {"aten::gradient", "array"},
    {"aten::gradient", "scalarrayint"},
    {"aten::gradient", "scalarrayarray"},
    {"aten::gradient", "tensorarrayint"},
    {"aten::gradient", "tensorarray"},
    {"aten::div", "Tensor"},
    {"aten::div_", "Tensor"},
    {"aten::div", "out"},
    {"aten::div", "Tensor_mode"},
    {"aten::div_", "Tensor_mode"},
    {"aten::div", "out_mode"},
    {"aten::div", "Scalar"},
    {"aten::div_", "Scalar"},
    {"aten::div", "Scalar_mode"},
    {"aten::div_", "Scalar_mode"},
    {"aten::divide", "Tensor"},
    {"aten::divide_", "Tensor"},
    {"aten::divide", "out"},
    {"aten::divide", "Scalar"},
    {"aten::divide_", "Scalar"},
    {"aten::divide", "Tensor_mode"},
    {"aten::divide_", "Tensor_mode"},
    {"aten::divide", "out_mode"},
    {"aten::divide", "Scalar_mode"},
    {"aten::divide_", "Scalar_mode"},
    {"aten::true_divide", "Tensor"},
    {"aten::true_divide_", "Tensor"},
    {"aten::true_divide", "out"},
    {"aten::true_divide", "Scalar"},
    {"aten::true_divide_", "Scalar"},
    {"aten::dot", ""},
    {"aten::dot", "out"},
    {"aten::vdot", ""},
    {"aten::vdot", "out"},
    {"aten::einsum", ""},
    {"aten::embedding", ""},
    {"aten::embedding_backward", ""},
    {"aten::embedding_dense_backward", ""},
    {"aten::embedding_renorm_", ""},
    {"aten::embedding_sparse_backward", ""},
    {"aten::_embedding_bag_forward_only", ""},
    {"aten::_rowwise_prune", ""},
    {"aten::row_stack", ""},
    {"aten::row_stack", "out"},
    {"aten::embedding_bag", ""},
    {"aten::embedding_bag", "padding_idx"},
    {"aten::_embedding_bag", ""},
    {"aten::_embedding_bag_backward", ""},
    {"aten::_embedding_bag_sparse_backward", ""},
    {"aten::_embedding_bag_dense_backward", ""},
    {"aten::_embedding_bag_per_sample_weights_backward", ""},
    {"aten::empty", "names"},
    {"aten::empty", "memory_format"},
    {"aten::new_empty", ""},
    {"aten::new_empty_strided", ""},
    {"aten::new_full", ""},
    {"aten::new_zeros", ""},
    {"aten::new_ones", ""},
    {"aten::_empty_affine_quantized", ""},
    {"aten::_empty_per_channel_affine_quantized", ""},
    {"aten::resize_", ""},
    {"aten::empty_quantized", ""},
    {"aten::empty", "out"},
    {"aten::empty_like", ""},
    {"aten::empty_strided", ""},
    {"aten::erf", ""},
    {"aten::erf_", ""},
    {"aten::erf", "out"},
    {"aten::erfc", ""},
    {"aten::erfc_", ""},
    {"aten::erfc", "out"},
    {"aten::exp", ""},
    {"aten::exp_", ""},
    {"aten::exp", "out"},
    {"aten::exp2", ""},
    {"aten::exp2_", ""},
    {"aten::exp2", "out"},
    {"aten::expm1", ""},
    {"aten::expm1_", ""},
    {"aten::expm1", "out"},
    {"aten::expand", ""},
    {"aten::expand_as", ""},
    {"aten::eye", ""},
    {"aten::eye", "m"},
    {"aten::eye", "out"},
    {"aten::eye", "m_out"},
    {"aten::flatten", "using_ints"},
    {"aten::flatten", "named_out_dim"},
    {"aten::flatten", "using_names"},
    {"aten::flatten", "DimnameList"},
    {"aten::unflatten", "int"},
    {"aten::unflatten", "Dimname"},
    {"aten::fill_", "Scalar"},
    {"aten::fill_", "Tensor"},
    {"aten::floor", ""},
    {"aten::floor_", ""},
    {"aten::floor", "out"},
    {"aten::floor_divide", ""},
    {"aten::floor_divide_", "Tensor"},
    {"aten::floor_divide", "out"},
    {"aten::floor_divide", "Scalar"},
    {"aten::floor_divide_", "Scalar"},
    {"aten::frac", ""},
    {"aten::frac_", ""},
    {"aten::frac", "out"},
    {"aten::full", "names"},
    {"aten::full", ""},
    {"aten::full", "out"},
    {"aten::full_like", ""},
    {"aten::from_file", ""},
    {"aten::gcd", "out"},
    {"aten::gcd", ""},
    {"aten::gcd_", ""},
    {"aten::lcm", "out"},
    {"aten::lcm", ""},
    {"aten::lcm_", ""},
    {"aten::grid_sampler", ""},
    {"aten::grid_sampler_2d", ""},
    {"aten::grid_sampler_2d_backward", ""},
    {"aten::_grid_sampler_2d_cpu_fallback", ""},
    {"aten::_grid_sampler_2d_cpu_fallback_backward", ""},
    {"aten::grid_sampler_3d", ""},
    {"aten::grid_sampler_3d_backward", ""},
    {"aten::hann_window", ""},
    {"aten::hann_window", "periodic"},
    {"aten::hamming_window", ""},
    {"aten::hamming_window", "periodic"},
    {"aten::hamming_window", "periodic_alpha"},
    {"aten::hamming_window", "periodic_alpha_beta"},
    {"aten::kaiser_window", ""},
    {"aten::kaiser_window", "periodic"},
    {"aten::kaiser_window", "beta"},
    {"aten::hinge_embedding_loss", ""},
    {"aten::group_norm", ""},
    {"aten::native_group_norm", ""},
    {"aten::native_group_norm_backward", ""},
    {"aten::_fft_r2c", ""},
    {"aten::_fft_r2c", "out"},
    {"aten::_fft_c2r", ""},
    {"aten::_fft_c2r", "out"},
    {"aten::_fft_c2c", ""},
    {"aten::_fft_c2c", "out"},
    {"aten::_cufft_get_plan_cache_size", ""},
    {"aten::_cufft_get_plan_cache_max_size", ""},
    {"aten::_cufft_set_plan_cache_max_size", ""},
    {"aten::_cufft_clear_plan_cache", ""},
    {"aten::index", "Tensor"},
    {"aten::index_copy_", ""},
    {"aten::index_copy", ""},
    {"aten::index_copy_", "dimname"},
    {"aten::index_copy", "dimname"},
    {"aten::index_put_", ""},
    {"aten::index_put", ""},
    {"aten::_index_put_impl_", ""},
    {"aten::instance_norm", ""},
    {"aten::inverse", ""},
    {"aten::inverse", "out"},
    {"aten::isclose", ""},
    {"aten::isin", "Tensor_Tensor_out"},
    {"aten::isin", "Tensor_Tensor"},
    {"aten::isin", "Tensor_Scalar_out"},
    {"aten::isin", "Tensor_Scalar"},
    {"aten::isin", "Scalar_Tensor_out"},
    {"aten::isin", "Scalar_Tensor"},
    {"aten::isnan", ""},
    {"aten::is_distributed", ""},
    {"aten::is_floating_point", ""},
    {"aten::is_complex", ""},
    {"aten::is_conj", ""},
    {"aten::_is_zerotensor", ""},
    {"aten::is_neg", ""},
    {"aten::isreal", ""},
    {"aten::is_nonzero", ""},
    {"aten::is_same_size", ""},
    {"aten::is_signed", ""},
    {"aten::is_inference", ""},
    {"aten::kl_div", ""},
    {"aten::kl_div_backward", ""},
    {"aten::kron", ""},
    {"aten::kron", "out"},
    {"aten::kthvalue", ""},
    {"aten::kthvalue", "values"},
    {"aten::kthvalue", "dimname"},
    {"aten::kthvalue", "dimname_out"},
    {"aten::layer_norm", ""},
    {"aten::native_layer_norm", ""},
    {"aten::_native_multi_head_self_attention", ""},
    {"aten::native_layer_norm_backward", ""},
    {"aten::nan_to_num", ""},
    {"aten::nan_to_num_", ""},
    {"aten::nan_to_num", "out"},
    {"aten::linear", ""},
    {"aten::linear", "out"},
    {"aten::mkldnn_linear", ""},
    {"aten::mkldnn_linear_backward_input", ""},
    {"aten::mkldnn_linear_backward_weights", ""},
    {"aten::mkldnn_linear_backward", ""},
    {"aten::fbgemm_linear_int8_weight_fp32_activation", ""},
    {"aten::fbgemm_linear_int8_weight", ""},
    {"aten::fbgemm_linear_quantize_weight", ""},
    {"aten::fbgemm_pack_gemm_matrix_fp16", ""},
    {"aten::fbgemm_linear_fp16_weight_fp32_activation", ""},
    {"aten::fbgemm_linear_fp16_weight", ""},
    {"aten::fbgemm_pack_quantized_matrix", ""},
    {"aten::fbgemm_pack_quantized_matrix", "KN"},
    {"aten::ldexp", "Tensor"},
    {"aten::ldexp_", ""},
    {"aten::ldexp", "out"},
    {"aten::linspace", ""},
    {"aten::linspace", "out"},
    {"aten::log", ""},
    {"aten::log_", ""},
    {"aten::log", "out"},
    {"aten::log10", ""},
    {"aten::log10_", ""},
    {"aten::log10", "out"},
    {"aten::log1p", ""},
    {"aten::log1p_", ""},
    {"aten::log1p", "out"},
    {"aten::log2", ""},
    {"aten::log2_", ""},
    {"aten::log2", "out"},
    {"aten::logaddexp", "out"},
    {"aten::logaddexp", ""},
    {"aten::logaddexp2", "out"},
    {"aten::logaddexp2", ""},
    {"aten::xlogy", "Tensor"},
    {"aten::xlogy", "Scalar_Self"},
    {"aten::xlogy", "Scalar_Other"},
    {"aten::xlogy_", "Tensor"},
    {"aten::xlogy_", "Scalar_Other"},
    {"aten::xlogy", "OutTensor"},
    {"aten::xlogy", "OutScalar_Self"},
    {"aten::xlogy", "OutScalar_Other"},
    {"aten::logdet", ""},
    {"aten::logspace", ""},
    {"aten::logspace", "out"},
    {"aten::log_softmax", "int"},
    {"aten::log_softmax", "Dimname"},
    {"aten::_log_softmax", ""},
    {"aten::_log_softmax", "out"},
    {"aten::_log_softmax_backward_data", ""},
    {"aten::_log_softmax_backward_data", "out"},
    {"aten::_logcumsumexp", ""},
    {"aten::_logcumsumexp", "out"},
    {"aten::logcumsumexp", ""},
    {"aten::logcumsumexp", "out"},
    {"aten::logcumsumexp", "dimname"},
    {"aten::logcumsumexp", "dimname_out"},
    {"aten::logsumexp", ""},
    {"aten::logsumexp", "out"},
    {"aten::logsumexp", "names"},
    {"aten::logsumexp", "names_out"},
    {"aten::margin_ranking_loss", ""},
    {"aten::matmul", ""},
    {"aten::matmul", "out"},
    {"aten::matrix_rank", "tol"},
    {"aten::matrix_rank", ""},
    {"aten::matrix_power", ""},
    {"aten::matrix_power", "out"},
    {"aten::matrix_exp", ""},
    {"aten::matrix_exp_backward", ""},
    {"aten::_aminmax", ""},
    {"aten::_aminmax", "dim"},
    {"aten::aminmax", ""},
    {"aten::aminmax", "out"},
    {"aten::_compute_linear_combination", ""},
    {"aten::_compute_linear_combination", "out"},
    {"aten::max", "dim"},
    {"aten::max", "dim_max"},
    {"aten::max", "names_dim"},
    {"aten::max", "names_dim_max"},
    {"aten::value_selecting_reduction_backward", ""},
    {"aten::amax", ""},
    {"aten::amax", "out"},
    {"aten::max_pool1d_with_indices", ""},
    {"aten::max_pool1d", ""},
    {"aten::max_pool2d", ""},
    {"aten::mkldnn_max_pool2d", ""},
    {"aten::mkldnn_max_pool2d_backward", ""},
    {"aten::mkldnn_max_pool3d", ""},
    {"aten::mkldnn_max_pool3d_backward", ""},
    {"aten::quantized_max_pool1d", ""},
    {"aten::quantized_max_pool2d", ""},
    {"aten::max_pool3d", ""},
    {"aten::mean", ""},
    {"aten::mean", "dim"},
    {"aten::mean", "out"},
    {"aten::mean", "names_dim"},
    {"aten::mean", "names_out"},
    {"aten::nanmean", ""},
    {"aten::nanmean", "out"},
    {"aten::median", ""},
    {"aten::median", "dim"},
    {"aten::median", "dim_values"},
    {"aten::median", "names_dim"},
    {"aten::median", "names_dim_values"},
    {"aten::nanmedian", ""},
    {"aten::nanmedian", "dim"},
    {"aten::nanmedian", "dim_values"},
    {"aten::nanmedian", "names_dim"},
    {"aten::nanmedian", "names_dim_values"},
    {"aten::min", "dim"},
    {"aten::min", "dim_min"},
    {"aten::min", "names_dim"},
    {"aten::min", "names_dim_min"},
    {"aten::amin", ""},
    {"aten::amin", "out"},
    {"aten::mkldnn_convolution", ""},
    {"aten::miopen_batch_norm", ""},
    {"aten::miopen_batch_norm_backward", ""},
    {"aten::miopen_convolution", ""},
    {"aten::miopen_convolution_transpose", ""},
    {"aten::miopen_depthwise_convolution", ""},
    {"aten::miopen_rnn", ""},
    {"aten::miopen_rnn_backward", ""},
    {"aten::mm", ""},
    {"aten::mm", "out"},
    {"aten::_sparse_mm", ""},
    {"aten::_sparse_sparse_matmul", ""},
    {"aten::_sparse_mask_helper", ""},
    {"aten::mode", ""},
    {"aten::mode", "values"},
    {"aten::mode", "dimname"},
    {"aten::mode", "dimname_out"},
    {"aten::mul", "Tensor"},
    {"aten::mul_", "Tensor"},
    {"aten::mul", "out"},
    {"aten::mul", "Scalar"},
    {"aten::mul_", "Scalar"},
    {"aten::multiply", "Tensor"},
    {"aten::multiply_", "Tensor"},
    {"aten::multiply", "out"},
    {"aten::multiply", "Scalar"},
    {"aten::multiply_", "Scalar"},
    {"aten::mv", ""},
    {"aten::mv", "out"},
    {"aten::mvlgamma", "out"},
    {"aten::mvlgamma", ""},
    {"aten::mvlgamma_", ""},
    {"aten::narrow_copy", ""},
    {"aten::narrow_copy", "out"},
    {"aten::narrow", ""},
    {"aten::narrow", "Tensor"},
    {"aten::native_batch_norm", ""},
    {"aten::native_batch_norm", "out"},
    {"aten::batch_norm_stats", ""},
    {"aten::batch_norm_elemt", ""},
    {"aten::batch_norm_elemt", "out"},
    {"aten::batch_norm_gather_stats", ""},
    {"aten::batch_norm_gather_stats_with_counts", ""},
    {"aten::native_batch_norm_backward", ""},
    {"aten::batch_norm_backward_reduce", ""},
    {"aten::batch_norm_backward_elemt", ""},
    {"aten::batch_norm_update_stats", ""},
    {"aten::is_vulkan_available", ""},
    {"aten::_nnpack_available", ""},
    {"aten::_nnpack_spatial_convolution", ""},
    {"aten::ones", "names"},
    {"aten::ones", ""},
    {"aten::ones", "out"},
    {"aten::ones_like", ""},
    {"aten::pairwise_distance", ""},
    {"aten::cdist", ""},
    {"aten::_euclidean_dist", ""},
    {"aten::_cdist_forward", ""},
    {"aten::_cdist_backward", ""},
    {"aten::pdist", ""},
    {"aten::_pdist_forward", ""},
    {"aten::_pdist_backward", ""},
    {"aten::cosine_similarity", ""},
    {"aten::permute", ""},
    {"aten::movedim", "intlist"},
    {"aten::movedim", "int"},
    {"aten::moveaxis", "intlist"},
    {"aten::moveaxis", "int"},
    {"aten::numpy_T", ""},
    {"aten::matrix_H", ""},
    {"aten::mT", ""},
    {"aten::mH", ""},
    {"aten::adjoint", ""},
    {"aten::pixel_shuffle", ""},
    {"aten::pixel_unshuffle", ""},
    {"aten::channel_shuffle", ""},
    {"aten::native_channel_shuffle", ""},
    {"aten::is_pinned", ""},
    {"aten::pin_memory", ""},
    {"aten::_pin_memory", ""},
    {"aten::pinverse", ""},
    {"aten::poisson_nll_loss", ""},
    {"aten::rad2deg", ""},
    {"aten::rad2deg_", ""},
    {"aten::rad2deg", "out"},
    {"aten::deg2rad", ""},
    {"aten::deg2rad_", ""},
    {"aten::deg2rad", "out"},
    {"aten::scalar_tensor", ""},
    {"aten::rand", "names"},
    {"aten::rand", "generator_with_names"},
    {"aten::rand", ""},
    {"aten::rand", "generator"},
    {"aten::rand", "out"},
    {"aten::rand", "generator_out"},
    {"aten::rand_like", ""},
    {"aten::randint", ""},
    {"aten::randint", "generator"},
    {"aten::randint", "low"},
    {"aten::randint", "low_generator"},
    {"aten::randint", "out"},
    {"aten::randint", "generator_out"},
    {"aten::randint", "low_out"},
    {"aten::randint", "low_generator_out"},
    {"aten::randint_like", ""},
    {"aten::randint_like", "low_dtype"},
    {"aten::randn", ""},
    {"aten::randn", "generator"},
    {"aten::randn", "names"},
    {"aten::randn", "generator_with_names"},
    {"aten::randn", "out"},
    {"aten::randn", "generator_out"},
    {"aten::randn_like", ""},
    {"aten::randperm", ""},
    {"aten::randperm", "generator"},
    {"aten::randperm", "out"},
    {"aten::randperm", "generator_out"},
    {"aten::range", "step"},
    {"aten::range", ""},
    {"aten::range", "out"},
    {"aten::ravel", ""},
    {"aten::reciprocal", ""},
    {"aten::reciprocal_", ""},
    {"aten::reciprocal", "out"},
    {"aten::neg", ""},
    {"aten::neg_", ""},
    {"aten::neg", "out"},
    {"aten::negative", ""},
    {"aten::negative_", ""},
    {"aten::negative", "out"},
    {"aten::repeat", ""},
    {"aten::repeat_interleave", "Tensor"},
    {"aten::repeat_interleave", "self_Tensor"},
    {"aten::repeat_interleave", "self_int"},
    {"aten::reshape", ""},
    {"aten::_reshape_alias", ""},
    {"aten::_mkldnn_reshape", ""},
    {"aten::reshape_as", ""},
    {"aten::round", ""},
    {"aten::round_", ""},
    {"aten::round", "out"},
    {"aten::round", "decimals"},
    {"aten::round_", "decimals"},
    {"aten::round", "decimals_out"},
    {"aten::rrelu", ""},
    {"aten::rrelu_", ""},
    {"aten::relu", ""},
    {"aten::relu_", ""},
    {"aten::relu6", ""},
    {"aten::relu6_", ""},
    {"aten::prelu", ""},
    {"aten::prelu_backward", ""},
    {"aten::gelu", "out"},
    {"aten::gelu", ""},
    {"aten::gelu_backward", "grad_input"},
    {"aten::gelu_backward", ""},
    {"aten::infinitely_differentiable_gelu_backward", ""},
    {"aten::hardshrink", "out"},
    {"aten::hardshrink", ""},
    {"aten::hardshrink_backward", "grad_input"},
    {"aten::hardshrink_backward", ""},
    {"aten::rsqrt", ""},
    {"aten::rsqrt_", ""},
    {"aten::rsqrt", "out"},
    {"aten::select", "Dimname"},
    {"aten::select", "int"},
    {"aten::select_backward", ""},
    {"aten::selu", ""},
    {"aten::selu_", ""},
    {"aten::celu", ""},
    {"aten::celu_", ""},
    {"aten::silu", ""},
    {"aten::silu_", ""},
    {"aten::silu", "out"},
    {"aten::silu_backward", "grad_input"},
    {"aten::silu_backward", ""},
    {"aten::mish", ""},
    {"aten::mish_", ""},
    {"aten::mish", "out"},
    {"aten::mish_backward", ""},
    {"aten::sigmoid", ""},
    {"aten::sigmoid_", ""},
    {"aten::sigmoid", "out"},
    {"aten::logit", ""},
    {"aten::logit_", ""},
    {"aten::logit", "out"},
    {"aten::sin", ""},
    {"aten::sin_", ""},
    {"aten::sin", "out"},
    {"aten::sinc", ""},
    {"aten::sinc_", ""},
    {"aten::sinc", "out"},
    {"aten::sinh", ""},
    {"aten::sinh_", ""},
    {"aten::sinh", "out"},
    {"aten::detach", ""},
    {"aten::detach_", ""},
    {"aten::size", "int"},
    {"aten::size", "Dimname"},
    {"aten::slice", "Tensor"},
    {"aten::slice_backward", ""},
    {"aten::slice_scatter", ""},
    {"aten::select_scatter", ""},
    {"aten::diagonal_scatter", ""},
    {"aten::slogdet", ""},
    {"aten::smm", ""},
    {"aten::softmax", "int"},
    {"aten::softmax", "Dimname"},
    {"aten::_softmax", ""},
    {"aten::_softmax", "out"},
    {"aten::_softmax_backward_data", ""},
    {"aten::_softmax_backward_data", "out"},
    {"aten::unsafe_split", "Tensor"},
    {"aten::split", "Tensor"},
    {"aten::unsafe_split_with_sizes", ""},
    {"aten::split_with_sizes", ""},
    {"aten::hsplit", "int"},
    {"aten::hsplit", "array"},
    {"aten::vsplit", "int"},
    {"aten::vsplit", "array"},
    {"aten::dsplit", "int"},
    {"aten::dsplit", "array"},
    {"aten::squeeze", ""},
    {"aten::squeeze", "dim"},
    {"aten::squeeze", "dimname"},
    {"aten::squeeze_", ""},
    {"aten::squeeze_", "dim"},
    {"aten::squeeze_", "dimname"},
    {"aten::sspaddmm", ""},
    {"aten::sspaddmm", "out"},
    {"aten::stack", ""},
    {"aten::stack", "out"},
    {"aten::_stack", ""},
    {"aten::_stack", "out"},
    {"aten::hstack", ""},
    {"aten::hstack", "out"},
    {"aten::vstack", ""},
    {"aten::vstack", "out"},
    {"aten::dstack", ""},
    {"aten::dstack", "out"},
    {"aten::stft", ""},
    {"aten::istft", ""},
    {"aten::stride", "int"},
    {"aten::stride", "Dimname"},
    {"aten::sum", ""},
    {"aten::sum", "dim_IntList"},
    {"aten::sum", "dim_DimnameList"},
    {"aten::sum", "IntList_out"},
    {"aten::sum", "DimnameList_out"},
    {"aten::nansum", ""},
    {"aten::nansum", "dim_IntList"},
    {"aten::nansum", "IntList_out"},
    {"aten::sum_to_size", ""},
    {"aten::sqrt", ""},
    {"aten::sqrt_", ""},
    {"aten::sqrt", "out"},
    {"aten::square", ""},
    {"aten::square_", ""},
    {"aten::square", "out"},
    {"aten::std", ""},
    {"aten::std", "dim"},
    {"aten::std", "correction"},
    {"aten::std_mean", ""},
    {"aten::std_mean", "dim"},
    {"aten::std_mean", "correction"},
    {"aten::std_mean", "names_dim"},
    {"aten::std_mean", "correction_names"},
    {"aten::std", "out"},
    {"aten::std", "correction_out"},
    {"aten::std", "names_dim"},
    {"aten::std", "names_out"},
    {"aten::std", "correction_names"},
    {"aten::std", "correction_names_out"},
    {"aten::prod", ""},
    {"aten::prod", "dim_int"},
    {"aten::prod", "int_out"},
    {"aten::prod", "dim_Dimname"},
    {"aten::prod", "Dimname_out"},
    {"aten::t", ""},
    {"aten::t_", ""},
    {"aten::tan", ""},
    {"aten::tan_", ""},
    {"aten::tan", "out"},
    {"aten::tanh", ""},
    {"aten::tanh_", ""},
    {"aten::tanh", "out"},
    {"aten::tensordot", ""},
    {"aten::tensordot", "out"},
    {"aten::threshold", ""},
    {"aten::threshold_", ""},
    {"aten::threshold", "out"},
    {"aten::threshold_backward", "grad_input"},
    {"aten::threshold_backward", ""},
    {"aten::tile", ""},
    {"aten::transpose", "int"},
    {"aten::transpose", "Dimname"},
    {"aten::_mkldnn_transpose", ""},
    {"aten::transpose_", ""},
    {"aten::_mkldnn_transpose_", ""},
    {"aten::one_hot", ""},
    {"aten::flip", ""},
    {"aten::fliplr", ""},
    {"aten::flipud", ""},
    {"aten::roll", ""},
    {"aten::rot90", ""},
    {"aten::trapezoid", "x"},
    {"aten::trapezoid", "dx"},
    {"aten::trapz", "x"},
    {"aten::trapz", "dx"},
    {"aten::_trilinear", ""},
    {"aten::triplet_margin_loss", ""},
    {"aten::trunc", ""},
    {"aten::trunc_", ""},
    {"aten::trunc", "out"},
    {"aten::fix", ""},
    {"aten::fix_", ""},
    {"aten::fix", "out"},
    {"aten::type_as", ""},
    {"aten::_has_compatible_shallow_copy_type", ""},
    {"aten::_unique", ""},
    {"aten::unique_dim", ""},
    {"aten::unique_consecutive", ""},
    {"aten::unique_dim_consecutive", ""},
    {"aten::_unique2", ""},
    {"aten::_unsafe_view", ""},
    {"aten::unsqueeze", ""},
    {"aten::unsqueeze_", ""},
    {"aten::vander", ""},
    {"aten::var", ""},
    {"aten::var", "dim"},
    {"aten::var", "correction"},
    {"aten::var", "out"},
    {"aten::var", "correction_out"},
    {"aten::var", "names_dim"},
    {"aten::var", "names_out"},
    {"aten::var", "correction_names"},
    {"aten::var", "correction_names_out"},
    {"aten::var_mean", ""},
    {"aten::var_mean", "dim"},
    {"aten::var_mean", "correction"},
    {"aten::var_mean", "names_dim"},
    {"aten::var_mean", "correction_names"},
    {"aten::view_as", ""},
    {"aten::where", "self"},
    {"aten::where", "ScalarSelf"},
    {"aten::where", "ScalarOther"},
    {"aten::where", "Scalar"},
    {"aten::where", ""},
    {"aten::_s_where", ""},
    {"aten::norm_except_dim", ""},
    {"aten::_weight_norm", ""},
    {"aten::_weight_norm_cuda_interface", ""},
    {"aten::_weight_norm_cuda_interface_backward", ""},
    {"aten::_weight_norm_differentiable_backward", ""},
    {"aten::zeros", "names"},
    {"aten::_efficientzerotensor", ""},
    {"aten::zeros", ""},
    {"aten::zeros", "out"},
    {"aten::zeros_like", ""},
    {"aten::_standard_gamma_grad", ""},
    {"aten::_standard_gamma", ""},
    {"aten::_dirichlet_grad", ""},
    {"aten::_sample_dirichlet", ""},
    {"aten::poisson", ""},
    {"aten::binomial", ""},
    {"aten::native_norm", ""},
    {"aten::native_norm", "ScalarOpt_dim_dtype"},
    {"aten::_sparse_sum", ""},
    {"aten::_sparse_sum", "dtype"},
    {"aten::_sparse_sum", "dim"},
    {"aten::_sparse_sum", "dim_dtype"},
    {"aten::_sparse_sum_backward", ""},
    {"aten::_sparse_softmax", "int"},
    {"aten::_sparse_softmax", "Dimname"},
    {"aten::_sparse_softmax", ""},
    {"aten::_sparse_softmax_backward_data", ""},
    {"aten::_sparse_log_softmax", "int"},
    {"aten::_sparse_log_softmax", "Dimname"},
    {"aten::_sparse_log_softmax", ""},
    {"aten::_sparse_log_softmax_backward_data", ""},
    {"aten::norm", "ScalarOpt_dtype"},
    {"aten::norm", "Scalar"},
    {"aten::norm", "ScalarOpt_dim_dtype"},
    {"aten::norm", "ScalarOpt_dim"},
    {"aten::norm", "dtype_out"},
    {"aten::norm", "out"},
    {"aten::norm", "names_ScalarOpt_dim_dtype"},
    {"aten::norm", "names_ScalarOpt_dim"},
    {"aten::norm", "names_dtype_out"},
    {"aten::norm", "names_out"},
    {"aten::frexp", "Tensor"},
    {"aten::frexp", "Tensor_out"},
    {"aten::frobenius_norm", ""},
    {"aten::frobenius_norm", "dim"},
    {"aten::frobenius_norm", "out"},
    {"aten::nuclear_norm", ""},
    {"aten::nuclear_norm", "out"},
    {"aten::nuclear_norm", "dim"},
    {"aten::nuclear_norm", "dim_out"},
    {"aten::clone", ""},
    {"aten::positive", ""},
    {"aten::resize_as_", ""},
    {"aten::resize_as_sparse_", ""},
    {"aten::zero_", ""},
    {"aten::sub", "out"},
    {"aten::sub", "Tensor"},
    {"aten::sub_", "Tensor"},
    {"aten::sub", "Scalar"},
    {"aten::sub_", "Scalar"},
    {"aten::subtract", "out"},
    {"aten::subtract", "Tensor"},
    {"aten::subtract_", "Tensor"},
    {"aten::subtract", "Scalar"},
    {"aten::subtract_", "Scalar"},
    {"aten::rsub", "Tensor"},
    {"aten::heaviside", "out"},
    {"aten::heaviside", ""},
    {"aten::heaviside_", ""},
    {"aten::rsub", "Scalar"},
    {"aten::_sparse_addmm", ""},
    {"aten::sparse_sampled_addmm", "out"},
    {"aten::sparse_sampled_addmm", ""},
    {"aten::addmm", "out"},
    {"aten::addmm", ""},
    {"aten::addmm_", ""},
    {"aten::sparse_csr_tensor", "crow_col_value_size"},
    {"aten::sparse_csr_tensor", "crow_col_value"},
    {"aten::_sparse_csr_tensor_unsafe", ""},
    {"aten::sparse_coo_tensor", "size"},
    {"aten::sparse_coo_tensor", "indices"},
    {"aten::sparse_coo_tensor", "indices_size"},
    {"aten::_sparse_coo_tensor_unsafe", ""},
    {"aten::_validate_sparse_coo_tensor_args", ""},
    {"aten::_validate_sparse_csr_tensor_args", ""},
    {"aten::_sparse_coo_tensor_with_dims", ""},
    {"aten::_sparse_coo_tensor_with_dims_and_tensors", ""},
    {"aten::sparse_resize_", ""},
    {"aten::sparse_resize_and_clear_", ""},
    {"aten::sparse_mask", ""},
    {"aten::_to_cpu", ""},
    {"aten::to_dense", ""},
    {"aten::to_dense_backward", ""},
    {"aten::sparse_dim", ""},
    {"aten::_dimI", ""},
    {"aten::dense_dim", ""},
    {"aten::_dimV", ""},
    {"aten::_nnz", ""},
    {"aten::coalesce", ""},
    {"aten::_coalesce", ""},
    {"aten::is_coalesced", ""},
    {"aten::_indices", ""},
    {"aten::_values", ""},
    {"aten::_coalesced_", ""},
    {"aten::indices", ""},
    {"aten::values", ""},
    {"aten::crow_indices", ""},
    {"aten::col_indices", ""},
    {"aten::hspmm", "out"},
    {"aten::hspmm", ""},
    {"aten::copy_sparse_to_sparse_", ""},
    {"aten::unbind", "int"},
    {"aten::unbind", "Dimname"},
    {"aten::to_sparse", "sparse_dim"},
    {"aten::to_sparse", ""},
    {"aten::to_mkldnn", ""},
    {"aten::mkldnn_reorder_conv2d_weight", ""},
    {"aten::mkldnn_reorder_conv3d_weight", ""},
    {"aten::to_mkldnn_backward", ""},
    {"aten::quantize_per_tensor_dynamic", ""},
    {"aten::quantize_per_tensor", ""},
    {"aten::quantize_per_tensor", "tensor_qparams"},
    {"aten::quantize_per_tensor", "tensors"},
    {"aten::quantize_per_channel", ""},
    {"aten::dequantize", "self"},
    {"aten::dequantize", "tensors"},
    {"aten::q_scale", ""},
    {"aten::q_zero_point", ""},
    {"aten::q_per_channel_scales", ""},
    {"aten::q_per_channel_zero_points", ""},
    {"aten::q_per_channel_axis", ""},
    {"aten::int_repr", ""},
    {"aten::_make_per_tensor_quantized_tensor", ""},
    {"aten::_make_per_channel_quantized_tensor", ""},
    {"aten::qscheme", ""},
    {"aten::fake_quantize_per_tensor_affine", ""},
    {"aten::fake_quantize_per_tensor_affine", "tensor_qparams"},
    {"aten::fake_quantize_per_tensor_affine_cachemask", ""},
    {"aten::_fake_quantize_per_tensor_affine_cachemask_tensor_qparams", ""},
    {"aten::fake_quantize_per_tensor_affine_cachemask_backward", ""},
    {"aten::_fake_quantize_learnable_per_tensor_affine", ""},
    {"aten::_fake_quantize_learnable_per_tensor_affine_backward", ""},
    {"aten::fake_quantize_per_channel_affine", ""},
    {"aten::fake_quantize_per_channel_affine_cachemask", ""},
    {"aten::fake_quantize_per_channel_affine_cachemask_backward", ""},
    {"aten::_fake_quantize_learnable_per_channel_affine", ""},
    {"aten::_fake_quantize_learnable_per_channel_affine_backward", ""},
    {"aten::fused_moving_avg_obs_fake_quant", ""},
    {"aten::_fused_moving_avg_obs_fq_helper", ""},
    {"aten::_choose_qparams_per_tensor", ""},
    {"aten::_saturate_weight_to_fp16", ""},
    {"aten::choose_qparams_optimized", ""},
    {"aten::_autocast_to_reduced_precision", ""},
    {"aten::_autocast_to_full_precision", ""},
    {"aten::_to_copy", ""},
    {"aten::to", "dtype_layout"},
    {"aten::to", "device"},
    {"aten::to", "dtype"},
    {"aten::to", "other"},
    {"aten::meshgrid", ""},
    {"aten::meshgrid", "indexing"},
    {"aten::cartesian_prod", ""},
    {"aten::combinations", ""},
    {"aten::item", ""},
    {"aten::result_type", "Tensor"},
    {"aten::result_type", "Scalar"},
    {"aten::result_type", "Scalar_Tensor"},
    {"aten::result_type", "Scalar_Scalar"},
    {"aten::can_cast", ""},
    {"aten::promote_types", ""},
    {"aten::_local_scalar_dense", ""},
    {"aten::_thnn_fused_lstm_cell", ""},
    {"aten::_thnn_fused_lstm_cell_backward", ""},
    {"aten::_thnn_differentiable_lstm_cell_backward", ""},
    {"aten::_thnn_fused_gru_cell", ""},
    {"aten::_thnn_fused_gru_cell_backward", ""},
    {"aten::_thnn_differentiable_gru_cell_backward", ""},
    {"aten::lstm", "input"},
    {"aten::lstm", "data"},
    {"aten::gru", "input"},
    {"aten::gru", "data"},
    {"aten::rnn_tanh", "input"},
    {"aten::rnn_tanh", "data"},
    {"aten::rnn_relu", "input"},
    {"aten::rnn_relu", "data"},
    {"aten::lstm_cell", ""},
    {"aten::gru_cell", ""},
    {"aten::rnn_tanh_cell", ""},
    {"aten::rnn_relu_cell", ""},
    {"aten::quantized_lstm_cell", ""},
    {"aten::quantized_gru_cell", ""},
    {"aten::quantized_rnn_relu_cell", ""},
    {"aten::quantized_rnn_tanh_cell", ""},
    {"aten::_pack_padded_sequence", ""},
    {"aten::_pack_padded_sequence_backward", ""},
    {"aten::_pad_packed_sequence", ""},
    {"aten::set_", "source_Storage"},
    {"aten::set_", "source_Storage_storage_offset"},
    {"aten::set_", "source_Tensor"},
    {"aten::set_", ""},
    {"aten::is_set_to", ""},
    {"aten::masked_fill_", "Scalar"},
    {"aten::masked_fill", "Scalar"},
    {"aten::masked_fill_", "Tensor"},
    {"aten::masked_fill", "Tensor"},
    {"aten::masked_scatter_", ""},
    {"aten::masked_scatter", ""},
    {"aten::_masked_softmax", ""},
    {"aten::view", ""},
    {"aten::view", "dtype"},
    {"aten::put_", ""},
    {"aten::put", ""},
    {"aten::index_add", "out"},
    {"aten::index_add_", ""},
    {"aten::index_add", ""},
    {"aten::index_add", "dimname"},
    {"aten::index_fill_", "int_Scalar"},
    {"aten::index_fill", "int_Scalar"},
    {"aten::index_fill_", "int_Tensor"},
    {"aten::index_fill", "int_Tensor"},
    {"aten::index_fill_", "Dimname_Scalar"},
    {"aten::index_fill_", "Dimname_Tensor"},
    {"aten::index_fill", "Dimname_Scalar"},
    {"aten::index_fill", "Dimname_Tensor"},
    {"aten::scatter", "src"},
    {"aten::scatter_", "src"},
    {"aten::scatter", "src_out"},
    {"aten::scatter", "value"},
    {"aten::scatter_", "value"},
    {"aten::scatter", "value_out"},
    {"aten::scatter", "reduce"},
    {"aten::scatter_", "reduce"},
    {"aten::scatter", "reduce_out"},
    {"aten::scatter", "value_reduce"},
    {"aten::scatter_", "value_reduce"},
    {"aten::scatter", "value_reduce_out"},
    {"aten::scatter", "dimname_src"},
    {"aten::scatter", "dimname_value"},
    {"aten::scatter_add", ""},
    {"aten::scatter_add_", ""},
    {"aten::scatter_add", "out"},
    {"aten::scatter_add", "dimname"},
    {"aten::scatter_reduce", "two"},
    {"aten::eq_", "Scalar"},
    {"aten::eq_", "Tensor"},
    {"aten::bitwise_and", "Tensor_out"},
    {"aten::bitwise_and", "Scalar_out"},
    {"aten::bitwise_and", "Scalar"},
    {"aten::bitwise_and", "Tensor"},
    {"aten::bitwise_and_", "Scalar"},
    {"aten::bitwise_and_", "Tensor"},
    {"aten::__and__", "Scalar"},
    {"aten::__and__", "Tensor"},
    {"aten::__iand__", "Scalar"},
    {"aten::__iand__", "Tensor"},
    {"aten::bitwise_or", "Tensor_out"},
    {"aten::bitwise_or", "Scalar_out"},
    {"aten::bitwise_or", "Scalar"},
    {"aten::bitwise_or", "Tensor"},
    {"aten::bitwise_or_", "Scalar"},
    {"aten::bitwise_or_", "Tensor"},
    {"aten::__or__", "Scalar"},
    {"aten::__or__", "Tensor"},
    {"aten::__ior__", "Scalar"},
    {"aten::__ior__", "Tensor"},
    {"aten::bitwise_xor", "Tensor_out"},
    {"aten::bitwise_xor", "Scalar_out"},
    {"aten::bitwise_xor", "Scalar"},
    {"aten::bitwise_xor", "Tensor"},
    {"aten::bitwise_xor_", "Scalar"},
    {"aten::bitwise_xor_", "Tensor"},
    {"aten::__xor__", "Scalar"},
    {"aten::__xor__", "Tensor"},
    {"aten::__ixor__", "Scalar"},
    {"aten::__ixor__", "Tensor"},
    {"aten::__lshift__", "Scalar"},
    {"aten::__lshift__", "Tensor"},
    {"aten::__ilshift__", "Scalar"},
    {"aten::__ilshift__", "Tensor"},
    {"aten::bitwise_left_shift", "Tensor"},
    {"aten::bitwise_left_shift_", "Tensor"},
    {"aten::bitwise_left_shift", "Tensor_out"},
    {"aten::bitwise_left_shift", "Tensor_Scalar"},
    {"aten::bitwise_left_shift_", "Tensor_Scalar"},
    {"aten::bitwise_left_shift", "Tensor_Scalar_out"},
    {"aten::bitwise_left_shift", "Scalar_Tensor"},
    {"aten::__rshift__", "Scalar"},
    {"aten::__rshift__", "Tensor"},
    {"aten::__irshift__", "Scalar"},
    {"aten::__irshift__", "Tensor"},
    {"aten::bitwise_right_shift", "Tensor"},
    {"aten::bitwise_right_shift_", "Tensor"},
    {"aten::bitwise_right_shift", "Tensor_out"},
    {"aten::bitwise_right_shift", "Tensor_Scalar"},
    {"aten::bitwise_right_shift_", "Tensor_Scalar"},
    {"aten::bitwise_right_shift", "Tensor_Scalar_out"},
    {"aten::bitwise_right_shift", "Scalar_Tensor"},
    {"aten::tril_", ""},
    {"aten::triu_", ""},
    {"aten::digamma_", ""},
    {"aten::lerp_", "Scalar"},
    {"aten::lerp_", "Tensor"},
    {"aten::addbmm_", ""},
    {"aten::addbmm", "out"},
    {"aten::addbmm", ""},
    {"aten::random_", "from"},
    {"aten::random_", "to"},
    {"aten::random_", ""},
    {"aten::uniform_", ""},
    {"aten::cauchy_", ""},
    {"aten::log_normal_", ""},
    {"aten::exponential_", ""},
    {"aten::geometric_", ""},
    {"aten::diag", "out"},
    {"aten::diag", ""},
    {"aten::diag_backward", ""},
    {"aten::cross", "out"},
    {"aten::cross", ""},
    {"aten::triu", "out"},
    {"aten::triu", ""},
    {"aten::tril", "out"},
    {"aten::tril", ""},
    {"aten::tril_indices", ""},
    {"aten::triu_indices", ""},
    {"aten::trace", ""},
    {"aten::trace_backward", ""},
    {"aten::ne", "Scalar_out"},
    {"aten::ne", "Scalar"},
    {"aten::ne", "Tensor_out"},
    {"aten::ne", "Tensor"},
    {"aten::ne_", "Scalar"},
    {"aten::ne_", "Tensor"},
    {"aten::not_equal", "Scalar_out"},
    {"aten::not_equal", "Scalar"},
    {"aten::not_equal", "Tensor_out"},
    {"aten::not_equal", "Tensor"},
    {"aten::not_equal_", "Scalar"},
    {"aten::not_equal_", "Tensor"},
    {"aten::eq", "Scalar_out"},
    {"aten::eq", "Scalar"},
    {"aten::eq", "Tensor_out"},
    {"aten::eq", "Tensor"},
    {"aten::ge", "Scalar_out"},
    {"aten::ge", "Scalar"},
    {"aten::ge", "Tensor_out"},
    {"aten::ge", "Tensor"},
    {"aten::ge_", "Scalar"},
    {"aten::ge_", "Tensor"},
    {"aten::greater_equal", "Scalar_out"},
    {"aten::greater_equal", "Scalar"},
    {"aten::greater_equal", "Tensor_out"},
    {"aten::greater_equal", "Tensor"},
    {"aten::greater_equal_", "Scalar"},
    {"aten::greater_equal_", "Tensor"},
    {"aten::le", "Scalar_out"},
    {"aten::le", "Scalar"},
    {"aten::le", "Tensor_out"},
    {"aten::le", "Tensor"},
    {"aten::le_", "Scalar"},
    {"aten::le_", "Tensor"},
    {"aten::less_equal", "Scalar_out"},
    {"aten::less_equal", "Scalar"},
    {"aten::less_equal", "Tensor_out"},
    {"aten::less_equal", "Tensor"},
    {"aten::less_equal_", "Scalar"},
    {"aten::less_equal_", "Tensor"},
    {"aten::gt", "Scalar_out"},
    {"aten::gt", "Scalar"},
    {"aten::gt", "Tensor_out"},
    {"aten::gt", "Tensor"},
    {"aten::gt_", "Scalar"},
    {"aten::gt_", "Tensor"},
    {"aten::greater", "Scalar_out"},
    {"aten::greater", "Scalar"},
    {"aten::greater", "Tensor_out"},
    {"aten::greater", "Tensor"},
    {"aten::greater_", "Scalar"},
    {"aten::greater_", "Tensor"},
    {"aten::lt", "Scalar_out"},
    {"aten::lt", "Scalar"},
    {"aten::lt", "Tensor_out"},
    {"aten::lt", "Tensor"},
    {"aten::lt_", "Scalar"},
    {"aten::lt_", "Tensor"},
    {"aten::less", "Scalar_out"},
    {"aten::less", "Scalar"},
    {"aten::less", "Tensor_out"},
    {"aten::less", "Tensor"},
    {"aten::less_", "Scalar"},
    {"aten::less_", "Tensor"},
    {"aten::take", "out"},
    {"aten::take", ""},
    {"aten::take_along_dim", "out"},
    {"aten::take_along_dim", ""},
    {"aten::index_select", "out"},
    {"aten::index_select", ""},
    {"aten::index_select", "dimname_out"},
    {"aten::index_select", "dimname"},
    {"aten::index_select_backward", ""},
    {"aten::masked_select", "out"},
    {"aten::masked_select", ""},
    {"aten::masked_select_backward", ""},
    {"aten::nonzero", "out"},
    {"aten::nonzero", ""},
    {"aten::nonzero_numpy", ""},
    {"aten::argwhere", ""},
    {"aten::gather", "out"},
    {"aten::gather", ""},
    {"aten::gather_backward", ""},
    {"aten::gather", "dimname_out"},
    {"aten::gather", "dimname"},
    {"aten::_gather_sparse_backward", ""},
    {"aten::addcmul", "out"},
    {"aten::addcmul", ""},
    {"aten::addcmul_", ""},
    {"aten::addcdiv", "out"},
    {"aten::addcdiv", ""},
    {"aten::addcdiv_", ""},
    {"aten::cross_entropy_loss", ""},
    {"aten::lstsq", "X"},
    {"aten::lstsq", ""},
    {"aten::triangular_solve", "X"},
    {"aten::triangular_solve", ""},
    {"aten::_linalg_check_errors", ""},
    {"aten::linalg_solve_triangular", "out"},
    {"aten::linalg_solve_triangular", ""},
    {"aten::symeig", "e"},
    {"aten::symeig", ""},
    {"aten::_symeig_helper", ""},
    {"aten::eig", "e"},
    {"aten::eig", ""},
    {"aten::svd", "U"},
    {"aten::svd", ""},
    {"aten::swapaxes", ""},
    {"aten::swapaxes_", ""},
    {"aten::swapdims", ""},
    {"aten::swapdims_", ""},
    {"aten::cholesky", "out"},
    {"aten::cholesky", ""},
    {"aten::cholesky_solve", "out"},
    {"aten::cholesky_solve", ""},
    {"aten::_cholesky_solve_helper", ""},
    {"aten::solve", ""},
    {"aten::solve", "solution"},
    {"aten::_solve_helper", ""},
    {"aten::cholesky_inverse", ""},
    {"aten::cholesky_inverse", "out"},
    {"aten::qr", "Q"},
    {"aten::qr", ""},
    {"aten::geqrf", "a"},
    {"aten::geqrf", ""},
    {"aten::orgqr", ""},
    {"aten::orgqr", "out"},
    {"aten::ormqr", "out"},
    {"aten::ormqr", ""},
    {"aten::_lu_with_info", ""},
    {"aten::lu_solve", "out"},
    {"aten::lu_solve", ""},
    {"aten::lu_unpack", ""},
    {"aten::lu_unpack", "out"},
    {"aten::multinomial", "out"},
    {"aten::multinomial", ""},
    {"aten::lgamma", "out"},
    {"aten::lgamma_", ""},
    {"aten::lgamma", ""},
    {"aten::digamma", "out"},
    {"aten::digamma", ""},
    {"aten::polygamma", "out"},
    {"aten::polygamma", ""},
    {"aten::polygamma_", ""},
    {"aten::erfinv", ""},
    {"aten::erfinv_", ""},
    {"aten::erfinv", "out"},
    {"aten::i0", ""},
    {"aten::i0_", ""},
    {"aten::i0", "out"},
    {"aten::sign", ""},
    {"aten::sign_", ""},
    {"aten::sign", "out"},
    {"aten::signbit", ""},
    {"aten::signbit", "out"},
    {"aten::dist", ""},
    {"aten::atan2", "out"},
    {"aten::atan2_", ""},
    {"aten::atan2", ""},
    {"aten::arctan2", ""},
    {"aten::arctan2", "out"},
    {"aten::arctan2_", ""},
    {"aten::lerp", "Scalar_out"},
    {"aten::lerp", "Tensor_out"},
    {"aten::lerp", "Scalar"},
    {"aten::lerp", "Tensor"},
    {"aten::histc", "out"},
    {"aten::histc", ""},
    {"aten::histogram", "bins_tensor_out"},
    {"aten::histogram", "bins_tensor"},
    {"aten::histogram", "bin_ct_out"},
    {"aten::histogram", "bin_ct"},
    {"aten::_histogramdd_bin_edges", ""},
    {"aten::_histogramdd_from_bin_cts", ""},
    {"aten::_histogramdd_from_bin_tensors", ""},
    {"aten::fmod", "Scalar_out"},
    {"aten::fmod", "Scalar"},
    {"aten::fmod_", "Scalar"},
    {"aten::fmod", "Tensor_out"},
    {"aten::fmod", "Tensor"},
    {"aten::fmod_", "Tensor"},
    {"aten::hypot", "out"},
    {"aten::hypot", ""},
    {"aten::hypot_", ""},
    {"aten::igamma", "out"},
    {"aten::igamma", ""},
    {"aten::igamma_", ""},
    {"aten::igammac", "out"},
    {"aten::igammac", ""},
    {"aten::igammac_", ""},
    {"aten::nextafter", "out"},
    {"aten::nextafter", ""},
    {"aten::nextafter_", ""},
    {"aten::remainder", "Scalar_out"},
    {"aten::remainder", "Scalar"},
    {"aten::remainder_", "Scalar"},
    {"aten::remainder", "Tensor_out"},
    {"aten::remainder", "Tensor"},
    {"aten::remainder_", "Tensor"},
    {"aten::remainder", "Scalar_Tensor"},
    {"aten::min", ""},
    {"aten::fmin", ""},
    {"aten::fmin", "out"},
    {"aten::max", ""},
    {"aten::fmax", ""},
    {"aten::fmax", "out"},
    {"aten::maximum", ""},
    {"aten::maximum", "out"},
    {"aten::max", "other"},
    {"aten::max", "out"},
    {"aten::minimum", ""},
    {"aten::minimum", "out"},
    {"aten::min", "out"},
    {"aten::min", "other"},
    {"aten::quantile", ""},
    {"aten::quantile", "out"},
    {"aten::quantile", "scalar"},
    {"aten::quantile", "scalar_out"},
    {"aten::nanquantile", ""},
    {"aten::nanquantile", "out"},
    {"aten::nanquantile", "scalar"},
    {"aten::nanquantile", "scalar_out"},
    {"aten::sort", "values"},
    {"aten::sort", "values_stable"},
    {"aten::sort", ""},
    {"aten::sort", "stable"},
    {"aten::sort", "dimname_values"},
    {"aten::sort", "dimname_values_stable"},
    {"aten::sort", "dimname"},
    {"aten::sort", "dimname_stable"},
    {"aten::msort", "out"},
    {"aten::msort", ""},
    {"aten::argsort", ""},
    {"aten::argsort", "dimname"},
    {"aten::topk", "values"},
    {"aten::topk", ""},
    {"aten::all", ""},
    {"aten::all", "all_out"},
    {"aten::any", ""},
    {"aten::any", "all_out"},
    {"aten::renorm", "out"},
    {"aten::renorm", ""},
    {"aten::renorm_", ""},
    {"aten::unfold", ""},
    {"aten::unfold_backward", ""},
    {"aten::equal", ""},
    {"aten::pow", "Tensor_Tensor_out"},
    {"aten::pow", "Tensor_Tensor"},
    {"aten::pow", "Scalar_out"},
    {"aten::pow", "Scalar"},
    {"aten::pow", "Tensor_Scalar_out"},
    {"aten::pow", "Tensor_Scalar"},
    {"aten::pow_", "Scalar"},
    {"aten::pow_", "Tensor"},
    {"aten::float_power", "Tensor_Tensor_out"},
    {"aten::float_power", "Tensor_Tensor"},
    {"aten::float_power", "Scalar_out"},
    {"aten::float_power", "Scalar"},
    {"aten::float_power", "Tensor_Scalar_out"},
    {"aten::float_power", "Tensor_Scalar"},
    {"aten::float_power_", "Scalar"},
    {"aten::float_power_", "Tensor"},
    {"aten::normal_", ""},
    {"aten::normal", "Tensor_float_out"},
    {"aten::normal", "Tensor_float"},
    {"aten::normal", "float_Tensor_out"},
    {"aten::normal", "float_Tensor"},
    {"aten::normal", "Tensor_Tensor_out"},
    {"aten::normal", "Tensor_Tensor"},
    {"aten::normal", "float_float"},
    {"aten::normal", "float_float_out"},
    {"aten::alias", ""},
    {"aten::_index_copy_", ""},
    {"aten::_amp_foreach_non_finite_check_and_unscale_", ""},
    {"aten::_amp_update_scale_", ""},
    {"aten::_cat", ""},
    {"aten::_cat", "out"},
    {"aten::_foreach_add", "Scalar"},
    {"aten::_foreach_add_", "Scalar"},
    {"aten::_foreach_sub", "Scalar"},
    {"aten::_foreach_sub_", "Scalar"},
    {"aten::_foreach_mul", "Scalar"},
    {"aten::_foreach_mul_", "Scalar"},
    {"aten::_foreach_div", "Scalar"},
    {"aten::_foreach_div_", "Scalar"},
    {"aten::_foreach_add", "List"},
    {"aten::_foreach_add_", "List"},
    {"aten::_foreach_sub", "List"},
    {"aten::_foreach_sub_", "List"},
    {"aten::_foreach_mul", "List"},
    {"aten::_foreach_mul_", "List"},
    {"aten::_foreach_div", "List"},
    {"aten::_foreach_div_", "List"},
    {"aten::_foreach_add", "ScalarList"},
    {"aten::_foreach_add_", "ScalarList"},
    {"aten::_foreach_sub", "ScalarList"},
    {"aten::_foreach_sub_", "ScalarList"},
    {"aten::_foreach_div", "ScalarList"},
    {"aten::_foreach_div_", "ScalarList"},
    {"aten::_foreach_mul", "ScalarList"},
    {"aten::_foreach_mul_", "ScalarList"},
    {"aten::_foreach_exp", ""},
    {"aten::_foreach_zero_", ""},
    {"aten::_foreach_exp_", ""},
    {"aten::_foreach_sqrt", ""},
    {"aten::_foreach_sqrt_", ""},
    {"aten::_foreach_abs", ""},
    {"aten::_foreach_abs_", ""},
    {"aten::_foreach_acos", ""},
    {"aten::_foreach_acos_", ""},
    {"aten::_foreach_asin", ""},
    {"aten::_foreach_asin_", ""},
    {"aten::_foreach_atan", ""},
    {"aten::_foreach_atan_", ""},
    {"aten::_foreach_ceil", ""},
    {"aten::_foreach_ceil_", ""},
    {"aten::_foreach_cos", ""},
    {"aten::_foreach_cos_", ""},
    {"aten::_foreach_cosh", ""},
    {"aten::_foreach_cosh_", ""},
    {"aten::_foreach_erf", ""},
    {"aten::_foreach_erf_", ""},
    {"aten::_foreach_erfc", ""},
    {"aten::_foreach_erfc_", ""},
    {"aten::_foreach_expm1", ""},
    {"aten::_foreach_expm1_", ""},
    {"aten::_foreach_floor", ""},
    {"aten::_foreach_floor_", ""},
    {"aten::_foreach_log", ""},
    {"aten::_foreach_log_", ""},
    {"aten::_foreach_log10", ""},
    {"aten::_foreach_log10_", ""},
    {"aten::_foreach_log1p", ""},
    {"aten::_foreach_log1p_", ""},
    {"aten::_foreach_log2", ""},
    {"aten::_foreach_log2_", ""},
    {"aten::_foreach_neg", ""},
    {"aten::_foreach_neg_", ""},
    {"aten::_foreach_tan", ""},
    {"aten::_foreach_tan_", ""},
    {"aten::_foreach_tanh", ""},
    {"aten::_foreach_tanh_", ""},
    {"aten::_foreach_sin", ""},
    {"aten::_foreach_sin_", ""},
    {"aten::_foreach_sinh", ""},
    {"aten::_foreach_sinh_", ""},
    {"aten::_foreach_round", ""},
    {"aten::_foreach_round_", ""},
    {"aten::_foreach_lgamma", ""},
    {"aten::_foreach_lgamma_", ""},
    {"aten::_foreach_frac", ""},
    {"aten::_foreach_frac_", ""},
    {"aten::_foreach_reciprocal", ""},
    {"aten::_foreach_reciprocal_", ""},
    {"aten::_foreach_sigmoid", ""},
    {"aten::_foreach_sigmoid_", ""},
    {"aten::_foreach_trunc", ""},
    {"aten::_foreach_trunc_", ""},
    {"aten::_foreach_addcdiv_", "Scalar"},
    {"aten::_foreach_addcmul_", "Scalar"},
    {"aten::_foreach_addcdiv_", "ScalarList"},
    {"aten::_foreach_addcmul_", "ScalarList"},
    {"aten::_foreach_addcdiv", "Scalar"},
    {"aten::_foreach_addcmul", "Scalar"},
    {"aten::_foreach_addcdiv", "ScalarList"},
    {"aten::_foreach_addcmul", "ScalarList"},
    {"aten::_foreach_maximum", "List"},
    {"aten::_foreach_minimum", "List"},
    {"aten::_foreach_norm", "Scalar"},
    {"aten::bucketize", "Tensor"},
    {"aten::bucketize", "Tensor_out"},
    {"aten::bucketize", "Scalar"},
    {"aten::searchsorted", "Tensor"},
    {"aten::_torch_cuda_cu_linker_symbol_op", ""},
    {"aten::searchsorted", "Tensor_out"},
    {"aten::searchsorted", "Scalar"},
    {"aten::_convert_indices_from_coo_to_csr", ""},
    {"aten::_convert_indices_from_coo_to_csr", "out"},
    {"aten::_convert_indices_from_csr_to_coo", ""},
    {"aten::_convert_indices_from_csr_to_coo", "out"},
    {"aten::mse_loss", "out"},
    {"aten::mse_loss", ""},
    {"aten::mse_loss_backward", "grad_input"},
    {"aten::mse_loss_backward", ""},
    {"aten::l1_loss", "out"},
    {"aten::l1_loss", ""},
    {"aten::l1_loss_backward", "grad_input"},
    {"aten::l1_loss_backward", ""},
    {"aten::multi_margin_loss", "out"},
    {"aten::multi_margin_loss", ""},
    {"aten::multi_margin_loss_backward", "grad_input"},
    {"aten::multi_margin_loss_backward", ""},
    {"aten::multilabel_margin_loss", "out"},
    {"aten::multilabel_margin_loss", ""},
    {"aten::multilabel_margin_loss_forward", "output"},
    {"aten::multilabel_margin_loss_forward", ""},
    {"aten::multilabel_margin_loss_backward", "grad_input"},
    {"aten::multilabel_margin_loss_backward", ""},
    {"aten::nll_loss", "out"},
    {"aten::nll_loss_nd", ""},
    {"aten::nll_loss", ""},
    {"aten::nll_loss_forward", "output"},
    {"aten::nll_loss_forward", ""},
    {"aten::nll_loss_backward", "grad_input"},
    {"aten::nll_loss_backward", ""},
    {"aten::nll_loss2d", "out"},
    {"aten::nll_loss2d", ""},
    {"aten::nll_loss2d_forward", "output"},
    {"aten::nll_loss2d_forward", ""},
    {"aten::nll_loss2d_backward", "grad_input"},
    {"aten::nll_loss2d_backward", ""},
    {"aten::smooth_l1_loss", "out"},
    {"aten::smooth_l1_loss", ""},
    {"aten::smooth_l1_loss_backward", "grad_input"},
    {"aten::smooth_l1_loss_backward", ""},
    {"aten::huber_loss", "out"},
    {"aten::huber_loss", ""},
    {"aten::huber_loss_backward", "out"},
    {"aten::huber_loss_backward", ""},
    {"aten::soft_margin_loss", "out"},
    {"aten::soft_margin_loss", ""},
    {"aten::soft_margin_loss_backward", "grad_input"},
    {"aten::soft_margin_loss_backward", ""},
    {"aten::elu", "out"},
    {"aten::elu", ""},
    {"aten::elu_backward", "grad_input"},
    {"aten::elu_backward", ""},
    {"aten::elu_", ""},
    {"aten::glu", "out"},
    {"aten::glu", ""},
    {"aten::glu_backward", "grad_input"},
    {"aten::glu_backward", ""},
    {"aten::hardsigmoid", "out"},
    {"aten::hardsigmoid", ""},
    {"aten::hardsigmoid_", ""},
    {"aten::hardsigmoid_backward", "grad_input"},
    {"aten::hardsigmoid_backward", ""},
    {"aten::hardtanh", "out"},
    {"aten::hardtanh", ""},
    {"aten::hardtanh_backward", "grad_input"},
    {"aten::hardtanh_backward", ""},
    {"aten::hardtanh_", ""},
    {"aten::hardswish", "out"},
    {"aten::hardswish", ""},
    {"aten::hardswish_", ""},
    {"aten::hardswish_backward", ""},
    {"aten::leaky_relu", "out"},
    {"aten::leaky_relu", ""},
    {"aten::leaky_relu_backward", "grad_input"},
    {"aten::leaky_relu_backward", ""},
    {"aten::leaky_relu_", ""},
    {"aten::log_sigmoid", "out"},
    {"aten::log_sigmoid", ""},
    {"aten::log_sigmoid_forward", "output"},
    {"aten::log_sigmoid_forward", ""},
    {"aten::log_sigmoid_backward", "grad_input"},
    {"aten::log_sigmoid_backward", ""},
    {"aten::rrelu_with_noise", "out"},
    {"aten::rrelu_with_noise", ""},
    {"aten::rrelu_with_noise_backward", ""},
    {"aten::rrelu_with_noise_", ""},
    {"aten::softplus", "out"},
    {"aten::softplus", ""},
    {"aten::softplus_backward", "grad_input"},
    {"aten::softplus_backward", ""},
    {"aten::softshrink", "out"},
    {"aten::softshrink", ""},
    {"aten::softshrink_backward", "grad_input"},
    {"aten::softshrink_backward", ""},
    {"aten::adaptive_avg_pool2d", "out"},
    {"aten::adaptive_avg_pool2d", ""},
    {"aten::mkldnn_adaptive_avg_pool2d", ""},
    {"aten::mkldnn_adaptive_avg_pool2d_backward", ""},
    {"aten::_adaptive_avg_pool2d", ""},
    {"aten::_adaptive_avg_pool2d_backward", ""},
    {"aten::adaptive_avg_pool3d", "out"},
    {"aten::adaptive_avg_pool3d", ""},
    {"aten::_adaptive_avg_pool3d", ""},
    {"aten::adaptive_avg_pool3d_backward", "grad_input"},
    {"aten::_adaptive_avg_pool3d_backward", ""},
    {"aten::adaptive_max_pool2d", "out"},
    {"aten::adaptive_max_pool2d", ""},
    {"aten::adaptive_max_pool2d_backward", "grad_input"},
    {"aten::adaptive_max_pool2d_backward", ""},
    {"aten::adaptive_max_pool3d", "out"},
    {"aten::adaptive_max_pool3d", ""},
    {"aten::adaptive_max_pool3d_backward", "grad_input"},
    {"aten::adaptive_max_pool3d_backward", ""},
    {"aten::avg_pool2d", "out"},
    {"aten::avg_pool2d", ""},
    {"aten::avg_pool2d_backward", "grad_input"},
    {"aten::avg_pool2d_backward", ""},
    {"aten::avg_pool3d", "out"},
    {"aten::avg_pool3d", ""},
    {"aten::avg_pool3d_backward", "grad_input"},
    {"aten::avg_pool3d_backward", ""},
    {"aten::fractional_max_pool2d", "output"},
    {"aten::fractional_max_pool2d", ""},
    {"aten::fractional_max_pool2d_backward", "grad_input"},
    {"aten::fractional_max_pool2d_backward", ""},
    {"aten::fractional_max_pool3d", "output"},
    {"aten::fractional_max_pool3d", ""},
    {"aten::fractional_max_pool3d_backward", "grad_input"},
    {"aten::fractional_max_pool3d_backward", ""},
    {"aten::max_pool2d_with_indices", "out"},
    {"aten::max_pool2d_with_indices", ""},
    {"aten::max_pool2d_with_indices_backward", "grad_input"},
    {"aten::max_pool2d_with_indices_backward", ""},
    {"aten::max_pool3d_with_indices", "out"},
    {"aten::max_pool3d_with_indices", ""},
    {"aten::max_pool3d_with_indices_backward", "grad_input"},
    {"aten::max_pool3d_with_indices_backward", ""},
    {"aten::max_unpool2d", "out"},
    {"aten::max_unpool2d", ""},
    {"aten::max_unpool2d_backward", "grad_input"},
    {"aten::max_unpool2d_backward", ""},
    {"aten::max_unpool3d", "out"},
    {"aten::max_unpool3d", ""},
    {"aten::max_unpool3d_backward", "grad_input"},
    {"aten::max_unpool3d_backward", ""},
    {"aten::reflection_pad1d", "out"},
    {"aten::reflection_pad1d", ""},
    {"aten::reflection_pad1d_backward", "grad_input"},
    {"aten::reflection_pad1d_backward", ""},
    {"aten::reflection_pad2d", "out"},
    {"aten::reflection_pad2d", ""},
    {"aten::reflection_pad2d_backward", "grad_input"},
    {"aten::reflection_pad2d_backward", ""},
    {"aten::reflection_pad3d", "out"},
    {"aten::reflection_pad3d", ""},
    {"aten::reflection_pad3d_backward", "grad_input"},
    {"aten::reflection_pad3d_backward", ""},
    {"aten::replication_pad1d", "out"},
    {"aten::replication_pad1d", ""},
    {"aten::replication_pad1d_backward", "grad_input"},
    {"aten::replication_pad1d_backward", ""},
    {"aten::replication_pad2d", "out"},
    {"aten::replication_pad2d", ""},
    {"aten::replication_pad2d_backward", "grad_input"},
    {"aten::replication_pad2d_backward", ""},
    {"aten::replication_pad3d", "out"},
    {"aten::replication_pad3d", ""},
    {"aten::replication_pad3d_backward", "grad_input"},
    {"aten::replication_pad3d_backward", ""},
    {"aten::upsample_linear1d", "vec"},
    {"aten::upsample_linear1d_backward", "vec"},
    {"aten::upsample_bilinear2d", "vec"},
    {"aten::upsample_bilinear2d_backward", "vec"},
    {"aten::_upsample_bilinear2d_aa", "vec"},
    {"aten::_upsample_bilinear2d_aa_backward", "vec"},
    {"aten::upsample_trilinear3d", "vec"},
    {"aten::upsample_trilinear3d_backward", "vec"},
    {"aten::upsample_bicubic2d", "vec"},
    {"aten::upsample_bicubic2d_backward", "vec"},
    {"aten::_upsample_bicubic2d_aa", "vec"},
    {"aten::_upsample_bicubic2d_aa_backward", "vec"},
    {"aten::upsample_nearest1d", "vec"},
    {"aten::_upsample_nearest_exact1d", "vec"},
    {"aten::upsample_nearest1d_backward", "vec"},
    {"aten::_upsample_nearest_exact1d_backward", "vec"},
    {"aten::upsample_nearest2d", "vec"},
    {"aten::_upsample_nearest_exact2d", "vec"},
    {"aten::upsample_nearest2d_backward", "vec"},
    {"aten::_upsample_nearest_exact2d_backward", "vec"},
    {"aten::upsample_nearest3d", "vec"},
    {"aten::_upsample_nearest_exact3d", "vec"},
    {"aten::upsample_nearest3d_backward", "vec"},
    {"aten::_upsample_nearest_exact3d_backward", "vec"},
    {"aten::upsample_linear1d", "out"},
    {"aten::upsample_linear1d", ""},
    {"aten::upsample_linear1d_backward", "grad_input"},
    {"aten::upsample_linear1d_backward", ""},
    {"aten::upsample_bilinear2d", "out"},
    {"aten::upsample_bilinear2d", ""},
    {"aten::upsample_bilinear2d_backward", "grad_input"},
    {"aten::upsample_bilinear2d_backward", ""},
    {"aten::_upsample_bilinear2d_aa", "out"},
    {"aten::_upsample_bilinear2d_aa", ""},
    {"aten::_upsample_bilinear2d_aa_backward", "grad_input"},
    {"aten::_upsample_bilinear2d_aa_backward", ""},
    {"aten::upsample_bicubic2d", "out"},
    {"aten::upsample_bicubic2d", ""},
    {"aten::upsample_bicubic2d_backward", "grad_input"},
    {"aten::upsample_bicubic2d_backward", ""},
    {"aten::_upsample_bicubic2d_aa", "out"},
    {"aten::_upsample_bicubic2d_aa", ""},
    {"aten::_upsample_bicubic2d_aa_backward", "grad_input"},
    {"aten::_upsample_bicubic2d_aa_backward", ""},
    {"aten::upsample_trilinear3d", "out"},
    {"aten::upsample_trilinear3d", ""},
    {"aten::upsample_trilinear3d_backward", "grad_input"},
    {"aten::upsample_trilinear3d_backward", ""},
    {"aten::upsample_nearest1d", "out"},
    {"aten::_upsample_nearest_exact1d", "out"},
    {"aten::upsample_nearest1d", ""},
    {"aten::_upsample_nearest_exact1d", ""},
    {"aten::upsample_nearest1d_backward", "grad_input"},
    {"aten::_upsample_nearest_exact1d_backward", "grad_input"},
    {"aten::upsample_nearest1d_backward", ""},
    {"aten::_upsample_nearest_exact1d_backward", ""},
    {"aten::upsample_nearest2d", "out"},
    {"aten::_upsample_nearest_exact2d", "out"},
    {"aten::upsample_nearest2d", ""},
    {"aten::_upsample_nearest_exact2d", ""},
    {"aten::upsample_nearest2d_backward", "grad_input"},
    {"aten::_upsample_nearest_exact2d_backward", "grad_input"},
    {"aten::upsample_nearest2d_backward", ""},
    {"aten::_upsample_nearest_exact2d_backward", ""},
    {"aten::upsample_nearest3d", "out"},
    {"aten::_upsample_nearest_exact3d", "out"},
    {"aten::upsample_nearest3d", ""},
    {"aten::_upsample_nearest_exact3d", ""},
    {"aten::upsample_nearest3d_backward", "grad_input"},
    {"aten::_upsample_nearest_exact3d_backward", "grad_input"},
    {"aten::upsample_nearest3d_backward", ""},
    {"aten::_upsample_nearest_exact3d_backward", ""},
    {"aten::sigmoid_backward", "grad_input"},
    {"aten::sigmoid_backward", ""},
    {"aten::logit_backward", "grad_input"},
    {"aten::logit_backward", ""},
    {"aten::tanh_backward", "grad_input"},
    {"aten::tanh_backward", ""},
    {"aten::slow_conv_transpose2d", "out"},
    {"aten::slow_conv_transpose2d", ""},
    {"aten::slow_conv_transpose3d", "out"},
    {"aten::slow_conv_transpose3d", ""},
    {"aten::thnn_conv2d", "out"},
    {"aten::thnn_conv2d", ""},
    {"aten::_slow_conv2d_forward", "output"},
    {"aten::_slow_conv2d_forward", ""},
    {"aten::_slow_conv2d_backward", "grad_input"},
    {"aten::_slow_conv2d_backward", "output_mask"},
    {"aten::_conv_depthwise2d", "out"},
    {"aten::_conv_depthwise2d", ""},
    {"aten::conv_depthwise3d", ""},
    {"aten::slow_conv3d", "out"},
    {"aten::slow_conv3d", ""},
    {"aten::slow_conv3d_forward", "output"},
    {"aten::slow_conv3d_forward", ""},
    {"aten::slow_conv_dilated2d", ""},
    {"aten::slow_conv_dilated3d", ""},
    {"aten::col2im", "out"},
    {"aten::col2im", ""},
    {"aten::col2im_backward", "grad_input"},
    {"aten::col2im_backward", ""},
    {"aten::column_stack", ""},
    {"aten::column_stack", "out"},
    {"aten::im2col", "out"},
    {"aten::im2col", ""},
    {"aten::im2col_backward", "grad_input"},
    {"aten::im2col_backward", ""},
    {"aten::isfinite", ""},
    {"aten::isinf", ""},
    {"aten::record_stream", ""},
    {"aten::isposinf", ""},
    {"aten::isposinf", "out"},
    {"aten::isneginf", ""},
    {"aten::isneginf", "out"},
    {"aten::_add_batch_dim", ""},
    {"aten::_remove_batch_dim", ""},
    {"aten::special_entr", ""},
    {"aten::special_entr", "out"},
    {"aten::special_ndtri", ""},
    {"aten::special_ndtri", "out"},
    {"aten::special_expm1", ""},
    {"aten::special_expm1", "out"},
    {"aten::special_exp2", ""},
    {"aten::special_exp2", "out"},
    {"aten::special_psi", ""},
    {"aten::special_psi", "out"},
    {"aten::special_digamma", ""},
    {"aten::special_digamma", "out"},
    {"aten::special_gammaln", ""},
    {"aten::special_gammaln", "out"},
    {"aten::special_erf", ""},
    {"aten::special_erf", "out"},
    {"aten::special_erfc", ""},
    {"aten::special_erfc", "out"},
    {"aten::special_erfcx", ""},
    {"aten::special_erfcx", "out"},
    {"aten::special_erfinv", ""},
    {"aten::special_erfinv", "out"},
    {"aten::special_ndtr", ""},
    {"aten::special_ndtr", "out"},
    {"aten::special_xlog1py", ""},
    {"aten::special_xlog1py", "self_scalar"},
    {"aten::special_xlog1py", "other_scalar"},
    {"aten::special_xlog1py", "out"},
    {"aten::special_xlog1py", "self_scalar_out"},
    {"aten::special_xlog1py", "other_scalar_out"},
    {"aten::special_xlogy", ""},
    {"aten::special_xlogy", "self_scalar"},
    {"aten::special_xlogy", "other_scalar"},
    {"aten::special_xlogy", "out"},
    {"aten::special_xlogy", "self_scalar_out"},
    {"aten::special_xlogy", "other_scalar_out"},
    {"aten::special_zeta", ""},
    {"aten::special_zeta", "self_scalar"},
    {"aten::special_zeta", "other_scalar"},
    {"aten::special_zeta", "out"},
    {"aten::special_zeta", "self_scalar_out"},
    {"aten::special_zeta", "other_scalar_out"},
    {"aten::special_i0", ""},
    {"aten::special_i0", "out"},
    {"aten::special_i0e", ""},
    {"aten::special_i0e", "out"},
    {"aten::special_i1", ""},
    {"aten::special_i1", "out"},
    {"aten::special_i1e", ""},
    {"aten::special_i1e", "out"},
    {"aten::special_logit", ""},
    {"aten::special_logit", "out"},
    {"aten::special_polygamma", ""},
    {"aten::special_polygamma", "out"},
    {"aten::special_logsumexp", ""},
    {"aten::special_logsumexp", "out"},
    {"aten::special_expit", ""},
    {"aten::special_expit", "out"},
    {"aten::special_sinc", ""},
    {"aten::special_sinc", "out"},
    {"aten::special_round", ""},
    {"aten::special_round", "out"},
    {"aten::special_log1p", ""},
    {"aten::special_log1p", "out"},
    {"aten::special_log_softmax", ""},
    {"aten::special_gammainc", "out"},
    {"aten::special_gammainc", ""},
    {"aten::special_gammaincc", "out"},
    {"aten::special_gammaincc", ""},
    {"aten::special_multigammaln", ""},
    {"aten::special_multigammaln", "out"},
    {"aten::special_softmax", ""},
    {"aten::fft_fft", ""},
    {"aten::fft_fft", "out"},
    {"aten::fft_ifft", ""},
    {"aten::fft_ifft", "out"},
    {"aten::fft_rfft", ""},
    {"aten::fft_rfft", "out"},
    {"aten::fft_irfft", ""},
    {"aten::fft_irfft", "out"},
    {"aten::fft_hfft", ""},
    {"aten::fft_hfft", "out"},
    {"aten::fft_ihfft", ""},
    {"aten::fft_ihfft", "out"},
    {"aten::fft_fft2", ""},
    {"aten::fft_fft2", "out"},
    {"aten::fft_ifft2", ""},
    {"aten::fft_ifft2", "out"},
    {"aten::fft_rfft2", ""},
    {"aten::fft_rfft2", "out"},
    {"aten::fft_irfft2", ""},
    {"aten::fft_irfft2", "out"},
    {"aten::fft_hfft2", ""},
    {"aten::fft_hfft2", "out"},
    {"aten::fft_ihfft2", ""},
    {"aten::fft_ihfft2", "out"},
    {"aten::fft_fftn", ""},
    {"aten::fft_fftn", "out"},
    {"aten::fft_ifftn", ""},
    {"aten::fft_ifftn", "out"},
    {"aten::fft_rfftn", ""},
    {"aten::fft_rfftn", "out"},
    {"aten::fft_irfftn", ""},
    {"aten::fft_irfftn", "out"},
    {"aten::fft_hfftn", ""},
    {"aten::fft_hfftn", "out"},
    {"aten::fft_ihfftn", ""},
    {"aten::fft_ihfftn", "out"},
    {"aten::fft_fftfreq", ""},
    {"aten::fft_fftfreq", "out"},
    {"aten::fft_rfftfreq", ""},
    {"aten::fft_rfftfreq", "out"},
    {"aten::fft_fftshift", ""},
    {"aten::fft_ifftshift", ""},
    {"aten::linalg_cholesky_ex", ""},
    {"aten::linalg_cholesky_ex", "L"},
    {"aten::linalg_cholesky", ""},
    {"aten::linalg_cholesky", "out"},
    {"aten::linalg_cross", ""},
    {"aten::linalg_cross", "out"},
    {"aten::linalg_lu_factor", ""},
    {"aten::linalg_lu_factor", "out"},
    {"aten::linalg_lu_factor_ex", ""},
    {"aten::linalg_lu_factor_ex", "out"},
    {"aten::linalg_det", ""},
    {"aten::linalg_det", "out"},
    {"aten::det", ""},
    {"aten::_det_lu_based_helper", ""},
    {"aten::_det_lu_based_helper_backward_helper", ""},
    {"aten::linalg_lstsq", ""},
    {"aten::linalg_lstsq", "out"},
    {"aten::linalg_matmul", ""},
    {"aten::linalg_matmul", "out"},
    {"aten::linalg_matrix_exp", ""},
    {"aten::linalg_slogdet", ""},
    {"aten::linalg_slogdet", "out"},
    {"aten::linalg_eig", ""},
    {"aten::linalg_eig", "out"},
    {"aten::linalg_eigvals", ""},
    {"aten::linalg_eigvals", "out"},
    {"aten::linalg_eigh", ""},
    {"aten::linalg_eigh", "eigvals"},
    {"aten::linalg_eigvalsh", ""},
    {"aten::linalg_eigvalsh", "out"},
    {"aten::linalg_householder_product", ""},
    {"aten::linalg_householder_product", "out"},
    {"aten::_linalg_inv_out_helper_", ""},
    {"aten::linalg_inv_ex", ""},
    {"aten::linalg_inv_ex", "inverse"},
    {"aten::linalg_inv", ""},
    {"aten::linalg_inv", "out"},
    {"aten::inner", ""},
    {"aten::inner", "out"},
    {"aten::outer", ""},
    {"aten::outer", "out"},
    {"aten::ger", ""},
    {"aten::ger", "out"},
    {"aten::linalg_norm", ""},
    {"aten::linalg_norm", "ord_str"},
    {"aten::linalg_norm", "out"},
    {"aten::linalg_norm", "ord_str_out"},
    {"aten::linalg_vector_norm", ""},
    {"aten::linalg_vector_norm", "out"},
    {"aten::linalg_matrix_norm", ""},
    {"aten::linalg_matrix_norm", "out"},
    {"aten::linalg_matrix_norm", "str_ord"},
    {"aten::linalg_matrix_norm", "str_ord_out"},
    {"aten::_linalg_svd", ""},
    {"aten::_linalg_svd", "U"},
    {"aten::linalg_svd", ""},
    {"aten::linalg_svd", "U"},
    {"aten::linalg_svdvals", ""},
    {"aten::linalg_svdvals", "out"},
    {"aten::linalg_cond", ""},
    {"aten::linalg_cond", "out"},
    {"aten::linalg_cond", "p_str"},
    {"aten::linalg_cond", "p_str_out"},
    {"aten::linalg_pinv", "atol_rtol_tensor"},
    {"aten::linalg_pinv", "atol_rtol_tensor_out"},
    {"aten::linalg_pinv", "atol_rtol_float"},
    {"aten::linalg_pinv", "atol_rtol_float_out"},
    {"aten::linalg_pinv", ""},
    {"aten::linalg_pinv", "rcond_tensor"},
    {"aten::linalg_pinv", "out"},
    {"aten::linalg_pinv", "out_rcond_tensor"},
    {"aten::linalg_solve", ""},
    {"aten::linalg_solve", "out"},
    {"aten::linalg_tensorinv", ""},
    {"aten::linalg_tensorinv", "out"},
    {"aten::linalg_tensorsolve", ""},
    {"aten::linalg_tensorsolve", "out"},
    {"aten::linalg_qr", ""},
    {"aten::linalg_qr", "out"},
    {"aten::_linalg_qr_helper", ""},
    {"aten::linalg_matrix_power", ""},
    {"aten::linalg_matrix_power", "out"},
    {"aten::linalg_matrix_rank", "atol_rtol_tensor"},
    {"aten::linalg_matrix_rank", "atol_rtol_tensor_out"},
    {"aten::linalg_matrix_rank", "atol_rtol_float"},
    {"aten::linalg_matrix_rank", "atol_rtol_float_out"},
    {"aten::linalg_matrix_rank", ""},
    {"aten::linalg_matrix_rank", "out"},
    {"aten::linalg_matrix_rank", "tol_tensor"},
    {"aten::linalg_matrix_rank", "out_tol_tensor"},
    {"aten::linalg_multi_dot", ""},
    {"aten::linalg_multi_dot", "out"},
    {"aten::_test_serialization_subcmul", ""},
    {"aten::_test_optional_intlist", ""},
    {"aten::_test_optional_filled_intlist", ""},
    {"aten::_test_optional_floatlist", ""},
    {"aten::_test_string_default", ""},
    {"aten::_test_ambiguous_defaults", "a"},
    {"aten::_test_ambiguous_defaults", "b"},
    {"aten::_test_warn_in_autograd", ""},
    {"aten::segment_reduce", ""},
    {"aten::_segment_reduce_backward", ""},
    {"aten::pad_sequence", ""},
    {"aten::flatten_dense_tensors", ""},
    {"aten::unflatten_dense_tensors", ""},
    {"", ""}
  };
  return ops.count(std::make_pair(
             opName.name.c_str(), opName.overload_name.c_str())) == 0;
}
}
